ExamDiff Pro

ExamDiff Pro icon ExamDiff Pro

Version 4.5
Copyright 1997-2009 PrestoSoft LLC

ExamDiff Pro is a powerful yet intuitive and easy to use visual file and directory comparison tool for Windows 98/Me/NT/2000/XP/2003/Vista. If you've been frustrated with other comparison utilities, you will find that ExamDiff Pro offers a much more efficient and user-friendly way to compare files and folders.

ExamDiff Pro features a double-pane view that allows for side-by-side comparisons, with customizable color-coding indicating whether each line is added, deleted, or changed. ExamDiff Pro compares files and directories with equal ease, and boasts one of the fastest comparison algorithms of any tool today.

ExamDiff Pro offers such advanced features as fuzzy matching, moved block recognition, full Unicode support, word wrapping of long lines, automatic detection of changes in files or folders, drag and drop support, and the ability to preprocess compared files or folders via user-defined plug-ins. The program can also create “snapshots” of directories that can be compared later. Other features of ExamDiff Pro include regular expression filters, manual synchronization, named sessions, and comprehensive Ignore options.

Features

Help Contents


ExamDiff Pro Features

ExamDiff Pro by PrestoSoft LLC is a visual Windows tool for file and directory comparison. It has a number of simple and convenient features that many users have been expecting for a long time from a comparison program.

ExamDiff Pro:

  • Compares text files, binary files, and directories.
  • Highlights differences down to the level of lines, words or characters.
  • Features customizable syntax highlighting for document types, such as C++, Java, XML, and much more.
  • Uses fuzzy matching to intelligently align similar lines.
  • Allows the creation of manual links in file comparison.
  • Recognizes and marks moved blocks.
  • Allows editing files within file comparison panes.
  • Prints and print previews diff reports.
  • Includes full Unicode support
  • Allows creation of directory snapshots for later comparison.
  • Performs synchronous and simple word wrapping of long lines.
  • Remembers a user-specified number of last compared first and second files or directories.
  • Automatically detects file or directory changes and prompts the user to re-compare.
  • Includes a one-click re-compare function that attempts to leave the viewer's focus in the same place as before the re-compare.
  • Features extensive drag and drop support.
  • Allows file or directory comparison from the directory comparison panes with a simple double-click on one of the files or directories to be compared.
  • Allows the copying, renaming, and deleting files or directories from the directory comparison panes via menu, toolbar buttons, or a right button pop up. Any of these operations is followed by automatic re-synchronization of the compared directories. You can also sort directories in the left or the right pane by name, size, type, or last modification time without losing synchronization.
  • Saves the differences as a Unix, HTML, or printable diff report.
  • Enables easy navigation through the differences both via "Next Difference"/"Current Difference"/"Previous Difference" buttons and hot keys and via a list box of all the differences.
  • Allows the copying of text from the file comparison panes via drag and drop, a hot key, or a right button pop up.
  • Includes a simple "Search" command to search for strings in the comparison panes. It also remembers a user-specified number of most recent searches, as well as allowing regular-expression searches.
  • Features customizable colors.
  • Includes a fully customizable file name, extension, and/or path filter for directory comparison. For example, the user can choose only .c and .cpp files or any other files he/she chooses to be compared.
  • Includes support for name filter sets, and preinstalled filter sets for C++, Delphi, XML, and much more.
  • Includes a customizable date and size filter for directory comparison.
  • Contains tooltips, which include file or directory properties (when the mouse cursor is placed over the pane title bars), difference number (when the cursor is over the yellow bar marking the current difference), and etc.
  • Features an adjustable pane splitter with smooth synchronized scrolling.
  • Allows easy toggling between horizontal and vertical splitter orientation as well as splitter centering and hiding of panes.

The latest version of ExamDiff Pro can always be downloaded here.

The freeware version of ExamDiff Pro is called ExamDiff. It doesn't have all the features of ExamDiff Pro, such as directory comparison. ExamDiff can be downloaded here.

ExamDiff is a part of a suite of products that includes FtpVC, a tool for FTP-based version control. FtpVC allows joint software development remotely over the Internet. For the latest version of FtpVC please visit the FtpVC home page.


Getting Started

Comparing files or directories with ExamDiff Pro is very simple: when the program starts, it presents the Compare dialog where names of files or directories you wish to compare need to be specified (by typing, browsing to, or dropping one or two files/directories from Windows Explorer).

ExamDiff Pro main dialog

After comparison is finished, its results are shown in 2-pane window (ExamDiff Pro main window) with identical parts of compared files/directories synchronized, and modified parts identified as added (items unique to second file/directory), deleted (items unique to first file/directory), and changed (and also newer and older for timestamp-based directory comparison), and clearly marked by different colors. If files are compared, ExamDiff Pro automatically (unless forced by Options ) determines whether the files are text or binary, and shows comparison results in different views. Overall, there are three different comparison views: text file view, binary file view, and directory view.

Modified parts of compared items (files or directories) are referred to as blocks. ExamDiff Pro allows certain operations on blocks, such as deleting and copying from one item to another. ExamDiff Pro always maintains one block (or difference) as the current block (unless the compared items are identical), and block operations are performed on the current block.

ExamDiff Pro allows modifications to be viewed and printed. It provides multiple ways to navigate through them and allows synchronizing items via block operations or, in case of text files, via manual file editing using the built-it text editor.


Menus and Toolbars

ExamDiff Pro uses three different menus (as well as context menus) and toolbars, depending on the type of compared items: the Text File menu and toolbar, the Binary File menu and toolbar, and the Directory menu and toolbar. Toolbar buttons almost always perform same functions as corresponding menu commands. One notable exception is the Print toolbar button, which, unlike the File | Print or Directory | Print menu command, prints to the default printer without showing the Print Dialog. Toolbars can be hidden or customized.


Status Bars

ExamDiff Pro uses two kinds of status bars:

  1. Main status bar
  2. Pane status bars, different for text file panes, binary file panes, and directory panes.

Main status bar

Main status bar

The left area of the main status bar status bar shows the number of differences (blocks of changes) in the current comparison. For text file comparison, this area also shows the number of different lines, and, depending on the comparison detail level, the number of inline differences). For directory comparison, it also shows the number of different files/directories.

This area also describes actions of menu commands as you use the arrow keys to navigate through menus. It similarly shows messages that describe the actions of toolbar buttons as you move mouse over them.

During calculations of file CRCs and retrieving their versions in a background thread, a small progress bar appears at the end of this area.

The right areas of the main status bar show numbers of added, deleted, and changed blocks with appropriate colors. For text file comparison, the first number within a set of parentheses is the number of different complete lines, while the second number is the number of different inline blocks in changed lines. The "Changed in changed" area is the number of changed inline blocks - it is separated from the "Changed" area because these blocks use a different color from changed lines. The "Ignored" area shows the color of ignored blocks.

For directory comparison:

  • If both Compare subdirectories recursively and Perform full file comparison are enabled, the first number within a set of parentheses is the number of changed files and the second number is the number of changed lines within changed files.
  • If Compare subdirectories recursively but not Perform full file comparison is enabled, the numbers in parentheses are the number of changed files.
  • If Perform full file comparison but not Compare subdirectories recursively option is enabled, the first number within a set of parentheses is the number of changed directories, the second number is the number of changed files, and the third number is the number of changed lines within changed files.
  • If neither Perform full file comparison nor Compare subdirectories recursively is enabled, the first number within a set of parentheses is the number of changed directories and the second number is the number of changed files.

For binary comparison, the numbers in parentheses are the number of changed blocks.

Text file pane status bar

Text file pane status bar
  • The left area of this status bar describes the caret position based on the real line numbers. If the caret is positioned in the lines added for alignment of compared files, this area becomes blank.
  • The second area shows the number of lines in the file.
  • The third area shows INS if Insert mode is used, or OVR if Overwrite mode is used.
  • The fourth area describes whether file in the pane is read-only.
  • The fifth area shows whether internal editing is enabled.
  • The sixth area shows whether a plug-in was used for the current file. If this area has a red background, a plug-in returned a warning; double-clicking on the area will display the warning.
  • The seventh area shows whether file in the pane is newer or older than the other file.
  • The eighth area shows the size of the file.

Binary file pane status bar

Binary file pane status bar
  • The left area of this status bar describes the caret address based on the real addresses. If the caret is positioned in the bytes added for alignment of compared files, this area becomes blank.
  • The second area shows the size of the selection, again counting only real bytes.
  • The third area describes the value of the byte under the caret. If the caret is positioned in the bytes added for alignment of compared files, this area becomes blank.
  • The fourth area describes whether file in the pane is read-only.
  • The fifth area shows whether a plug-in was used for the current file. If this area has a red background, a plug-in returned a warning; double-clicking on the area will display the warning.
  • The sixth area shows whether file in the pane is newer or older than the other file.
  • The seventh area shows the size of the file.

Directory pane status bar

Directory pane status bar
  • The left area of this status bar describes the total number of files/directories in the pane. On the leftmost part of the left area, a filter icon is displayed if items were filtered out during comparison; if you hover over this icon the number of items filtered out is displayed in a balloon message.
  • The second area shows the number of selected files/directories in the pane.
  • The third area shows whether a plug-in was used for the current directory. If this area has a red background, a plug-in returned a warning; double-clicking on the area will display the warning.


Status Bars

Diff Bars

Diff bars

Each diff block has a diff bar showing its boundaries. The color of diff bars corresponds to the type of diff block:

  • Gray (shown at left): Normal diff block.
  • Yellow (shown at left): Selected diff block.
  • Green (shown at left): Resolved diff block (the difference has been resolved with a block operation). If all of the lines in the diff block were removed as a result of resolving the difference (eg. an added block was deleted), a small green diff bar is displayed at the top of the next line (shown at right).
  • Pink (shown at left): Moved block (the diff block appears in the opposite file in a different position).
  • Tan (shown at left): Skipped diff block (excluded from navigation). Blocks can be skipped using the Skip checkbox next to the diff combobox under the toolbar.
  • Yellow/Pink (shown at right): Selected moved block.
  • Tan/Pink (shown at right): Skipped moved block.

Clicking on a diff bar selects the diff block.

Right-clicking on a diff bar brings up a context menu. Information about its options can be found here.

Each diff bar (except for resolved diffs) contains a synchronization button. Clicking the button replaces the opposite diff block with the chosen diff block. Note that this operation is disabled if the files are out-of-sync due to manual addition or deletion of lines in either file, or if editing is disabled for any other reason.

The tooltip for each diff bar displays information about the difference. This information is also visible in the diff combobox under the toolbar.

 Diff bar - moved and selected block

Diff bar - moved and selected block

Diff bar - moved and skipped block


Context Menus

ExamDiff Pro uses three different context (mouse right-click) menus on text file panes, binary file panes, and directory panes respectively. All of them feature the Explorer Menu, which lists Windows shell menu commands as if you selected the file (for file comparison) or multiple files and/or directories (for directory comparison) in Windows Explorer and then use mouse right-click. Note that if you only want to see the Explorer menu, you can do so by using Shift + Mouse Right-Click.

In most cases, context menu commands match those of respective main menus. The exceptions are listed below.

In addition, there are also context menus for the diff bars, the file/directory names at the top of comparison panes, the toolbar, and the synchronizing splitter.

  • For text file panes
    • Save
      Save the file in the active pane.

    • Save As
      Save the file (or text fragment) in the active pane with a new name.

    • View/Edit
      Spawn an external program specified in the External editor field for file in the active pane.

    • Reset Line Modification Marks
      Clear line modification marks in the active pane.

    • Replace block in OTHER file
      Copy current difference FROM the file in the active pane TO the file in the other pane, replacing the difference in the other file.

    • Replace block in THIS file
      Copy current difference TO the file in the active pane FROM the file in the other pane, replacing the difference in the active file.

    • Add block to OTHER file
      Copy current difference FROM the file in the active pane TO the file in the other pane, keeping the difference in the other file. This operation is only enabled if the status of the difference is CHANGED.

    • Add block to THIS file
      Copy current difference TO the file in the active pane FROM the file in the other pane, keeping the difference in the active file. This operation is only enabled if the status of the difference is CHANGED.

    • Apply plug-in
      This sub-menu contains all plug-ins defined in Plug-in Options for the current session. When a plug-in is selected, it is applied to the contents of the active pane, thus modifying the file buffer. This modification is undoable.

    • Set syntax highlighting
      This sub-menu contains all system types defined in Document Types Options for the current session. When a document type is selected, its syntax highlighting is applied to the contents of the active pane. If "Default/Plain Text" is selected as the document type, no syntax highlighting is used.

  • For binary file panes
    • View/Edit
      Spawn an external program specified in the External binary editor field for file in the active pane.

  • For directory file panes
    • Save snapshot
      Save a snapshot of the directory in the active pane into a user-specified XML file. Snapshots may optionally contain CRCs of files and/or versions of executable files and DLLs (but choosing these options will slow down creation of a snapshot).

    • Refresh snapshot
      Refresh a snapshot of the directory in the active pane by updating the contents of the snapshot file.

    • View/Edit
      Spawn an external program specified in the External editor field for the selected file in the active pane.

    • Copy to OTHER directory
      Copy currently selected files/directories to directory in the other (not currently active) pane. If directories are copied, all their files/directories will be copied.

    • Copy to THIS directory
      Copy files/directories with the same names as currently selected ones in the active pane from directory in the other (not currently active) pane. If directories are copied, all their files/directories will be copied. Note that this command is disabled if Allow to copy files TO and FROM in directory comparison option in Directory Comparison Options is not selected.

    • Properties
      Show properties of the selected file/subdirectory. This command is disabled if more than one item is selected.

    • Resize columns to fit
      Resize all columns in the active pane to fit their contents. This command may take long time for large directory lists.

    • Filters
      • Exclude Name
        Adds the selected file's name to the Exclude Name Filter.

      • Exclude Extension
        Adds the selected file's extension to the Exclude Name Filter.

      • Exclude Relative Directory
        Adds the selected file's relative directory path to the Exclude Name Filter.

      • Not Older Than
        Filters out all files older than the selected file via the Date Filter.

      • Not Larger Than
        Filters out all files larger than the selected file via the Size Filter.

      • Not Smaller Than
        Filters out all files smaller than the selected file via the Size Filter.

  • For diff bars
    • Select Block
      Select the diff block.

    • Locate Matching Moved Block
      Locate the moved block in the opposite file that matches the current block.

    • Show Moved Blocks
      Enable or disable showing moved blocks.

    • Show Synchronization Buttons
      Enable or disable showing synchronization buttons.

  • For the file/directory names at the top of comparison panes
    • Copy path
      Copy the current file or directory path to the clipboard.

    • Open containing folder
      Open the folder containing the file or directory being compared in Windows Explorer.

  • For the toolbar
    • Hide
      Hide the toolbar. The toolbar can be shown again if by enabling the option View | Toolbar | Show.

    • Customize...
      Bring up a toolbar customization dialog box. More information on this dialog can be found here.

    • Reset to Default
      Reset the toolbar to the program default.

  • For the synchronizing splitter
    • Add link
      Add a manual synchronization link at the current location. This option is best used when the comparison panes are out of sync (see Synchronize vertical scrolling for more information on synchronized scrolling). Note that links can also be created by dragging them, as outlined here.

    • Delete link
      Delete the manual synchronization link at one of its endpoints. Note that this option can only be used at an endpoint (arrow) of the link, not in the center of it.

    • Delete all links
      Delete all manual synchronization links.

    • Previous link
      Navigate to the previous link not currently visible.

    • Next link
      Navigate to the next link not currently visible.

    • Show full link
      If only part of the manual synchronization link is shown, ExamDiff Pro will display the entire link, by scrolling one of the comparison panes or both (if possible). Note that this option will work even if Synchronize vertical scrolling is enabled - the panes will temporarily be out of sync.

    • Auto re-compare
      When this option is checked, as it is by default, ExamDiff Pro automatically re-compares the files whenever you add or remove a manual synchronization link.


Sessions

A session is a named entity that stores a pair of names of compared files or directories as well as a set of comparison options. There are two kinds of sessions, auto sessions, that are automatically stored by ExamDiff Pro in the Windows Registry, and standalone session files (files with .EDPI extension) that can be saved and loaded by ExamDiff Pro per user demand.

Sessions can be opened, loaded, and saved from the Files or Directories menu. When a session is loaded via the menu, ExamDiff Pro starts a new comparison. The Compare dialog gives even more options, such as creating, renaming, copying, and deleting sessions. The Compare dialog is the only place where auto sessions can be created.

When any session other than the <Unnamed Default Session> is currently being used, the title of ExamDiff Pro is ExamDiff Pro - Session Name ( file or dir | file or dir ).

Auto sessions and session files can be loaded when ExamDiff Pro starts via the /se and /sf command line options.

Session files can also be loaded by double-clicking on them in Windows Explorer.


File Editing

File Editing and Merging

ExamDiff Pro allows built-in file editing and synchronization for text files.

File editing can be enabled or disabled from the File Editing Options panel, which also includes other options related to file editing and saving.

There are two types of file editing operations: simple file editing and block operations.

  • Simple operations are those performed by adding, removing, or modifying text in either file.

  • Block operations are operations performed on blocks: Replace Block, Add Block, and Delete Block.

    If a block operation resolves the difference (e.g. you replace one block with the other, or you delete an added block), the difference is marked as "RESOLVED" in the diff combobox under the toolbar.

    Block operations can also change the type of difference (eg. deleting a changed block in the first file will result in an added block in the second file).

Whenever you add, modify, or delete a line, a yellow line modification mark is placed next the line number. Block operations add line modification marks as well. When a file is saved, all of its line modification marks become green.

The Undo and Redo commands are global (they affect both files), and can undo/redo recomparison operations (as long as no options were changed) in addition to file editing operations, enabling you to undo/redo past recomparison points.

Editing may be disabled for any of the following reasons:

  • Your evaluation license has expired.
  • A View filter is used
  • Word Wrap mode is on
  • In File Editing Options, the "Enable editing within ExamDiff Pro" option is disabled.
  • The files are out-of-sync due to manual addition or deletion of lines in either file (this only disables block operations; re-compare and try again).
  • Binary files are not editable.


Manual Synchronization

ExamDiff Pro includes easy-to-use graphical manual synchronization.

Because ExamDiff Pro matches strictly identical lines, sometimes lines that are nearly identical will end up being out of sync. Manual synchronization can be used in this situation to "help out" ExamDiff Pro's comparison algorithm by telling it that certain lines should be synchronized with each other.

Manual synchronization links can only be created if the synchronizing splitter is enabled. The synchronizing splitter can be toggled on or off in View | Synchronizing Splitter. The synchronizing splitter contains three areas: two darker areas used for setting manual links, and the lighter central area used for moving the splitter

Creating links

The easiest way to create a manual synchronization link is to click on the starting point (on one side of the synchronizing splitter) and then drag to the ending point on the opposite side. If you need to independently scroll one file, you can now use Alt + Scroll to do so.

Manual links can also be created by clicking on the synchronizing splitter or by right clicking on it and selecting Add Link. Links created in this way always connect the lines that are located at the point of clicking.

Two kinds of links are illegal: those that connect padding lines and those that cross existing links. ExamDiff Pro will show a different cursor when you drag an endpoint to an illegal location, and it will display an error message if you try to form one of these links. If you click beyond the end of the file, the link will be formed at the last line of the file instead.

Moving and deleting links

If you click on an existing link's endpoint and start dragging, two different outcomes are possible. If you drop the end while the mouse cursor is over the pane where you started dragging, the link will be moved. If you drop the end over the opposite pane, the link will be deleted. The mouse cursor changes its shape respectively while you drag the link's end.

Other commands

There are several link navigation commands and options available by right clicking on the synchronizing splitter. These are shown here.

By default, ExamDiff Pro automatically re-compares the two files whenever you add or remove manual links, but this option can be enabled or disabled by right clicking on the synchronizing splitter and selecting Auto Re-Compare from the context menu.

Note that while re-comparing keeps the arrangement of manual links, whenever you compare a new pair of files (or directories), your manual links will be lost.


Plug-ins

ExamDiff Pro provides an ability to preprocess files prior to comparison via the use of plug-ins. Any console application that converts files can be used as an ExamDiff Pro plug-in. A list of ExamDiff Pro-compatible plug-ins, along with setup instructions and download links (where applicable), can be found here.

Plug-ins can be executed in three different ways:

  • If a plug-in is enabled for certain extensions, it will be used to preprocess files with these extensions prior to comparison. If ‘*’ is given as a plug-in's extension, all files will be pre-processed by it. If more that one plug-in is enabled for an extension, all of them will be executed one by one in top-down order.
  • Plug-ins can also be explicitly specified, either in File Open dialog invoked from the Compare dialog, or inline in file/directory names (see Compare New Pair of Files/Directories for more information). If <inline> is set as a plug-in's extension or if no extension is set, the plug-in can only be used explicitly. A plug-in does not have to be enabled to be used explicitly.
  • If a file or directory is in the form of a URL (such as ftp://ftp.server.com/test.txt), the default remote file or directory comparison plug-in, respectively, will automatically used. These plug-ins are defined by setting their extension to <default-remote-file> or <default-remote-directory>, respectively. A plug-in has to be enabled to be used in this manner. There can only be one remote file and only one remote directory plug-in, and an error message will be given if you try to set more than one of either.

Plug-ins can also convert files to directories, in which case directory comparison will be eventually used instead of file comparison. One possible use is decompressing archive files so that they can be compared as directories. When a plug-in like this is used, you can compare the files in either the File or the Directory pane of the Compare dialog, and can you even choose to compare a file against a directory - no matter what pane you use, directory comparison will be used.

To view all plug-ins that you have installed, go to Plug-in Options (View | Options | Plug-ins) . To install a new plug-in, click on New... - you will be taken to this dialog. Also, when you install ExamDiff Pro, you can choose to automatically install certain plug-ins.


Drag and Drop

ExamDiff Pro provides extensive drag and drop support. ExamDiff Pro can participate in three different scenarios of drag and drop.

1. Drag and drop into ExamDiff Pro from another application

This includes support for dropping one or two files or directories into the program's window from Windows Explorer. If you select one file or directory, you can drop it into a comparison pane, and it will replace the file or directory in that comparison pane, and you will be prompted to recompare. If you select two files or directories, you can drop them anywhere in the program, and they will replace the current files or directories being compared (they will be compared to each other). Also, when comparing files, you can drag text blocks from an external editor. Finally, you can drop files or directories into certain dialog boxes that require a path to a file or directory, such as the Compare, Create Snapshot, and Copy to Third Directory dialogs.

2. Drag and drop from ExamDiff Pro into another application

When comparing directories, you can drag files or subdirectories into external editors, and to drag files or directories into Windows Explorer, which will result in them being copied to the currently selected directory in Windows Explorer. You can also drag a file or directory being compared by dragging its title box. Finally, you can drag text from a text file comparison pane into an external editor.

3. Drag and drop within ExamDiff Pro

When comparing text files, you can drag text blocks within files, and between the files being compared. When comparing directories, you can drag files between the two comparison panes, which results in them being copied from one pane to the other.


Unicode Support

ExamDiff Pro provides extensive Unicode support for file and directory comparison. Text files encoded in ASCII (ANSI), UTF-8, and UTF-16 (both little and big endian) formats are automatically recognized and compared (UTF-16 files are detected by byte order marks -- 0xFFFE for little endian and 0xFEFF for big endian). Full Unicode editing of text files is also supported, given that the required international keyboard is installed in Windows.

Directory comparison of files with names containing Unicode characters is fully supported as long as installed version of Windows provides such support. Windows 2000 and higher supports Unicode file names. Windows NT and Windows 9x family (95, 98, and ME) support this feature only if a localized version of Windows is installed.

Unicode support for Windows 9x is provided via Microsoft Layer for Unicode.


Command Line Options

Syntax

ExamDiff [Name1] [Name2] [Options]
or
ExamDiff /se:Session [Name1] [Name2]
or
ExamDiff /sf:SessionFile

Parameters

Name1, Name2 | names of files or directories to be compared
Session | name of the session to be used for comparison
SessionFile | name of the session file to be used for comparison
Options are any of the following:
/i | ignore case
/w | ignore all white space in lines
/b | ignore changes in amount of white space in lines
/l | ignore leading white space in lines
/e | ignore trailing white space in lines
/k | ignore blank lines
/j:RE | ignore lines matching regular expression RE
/br | briefly report whether files/directories differ
/t | treat both files as text files
/tb | treat both files as binary files
/d | use view filter
/q:M | set tab size to M characters
/s | consider files with same size and timestamp identical
/ic | consider files with same CRC identical
/y | consider files with different sizes different
/u | consider files with different attributes different
/z | consider files with different timestamps different
/dc | consider files with different CRC values different
/dv | consider files with different versions different
/r0 | do not compare subdirectories at all
/r1 | compare subdirectories only to determine their status
/r2 | compare subdirectories recursively
/fi:filter | specify include filter for directory comparison
/fx:filter | specify exclude filter for directory comparison
/f | report file differences during directory comparison (used with /o option and with full file comparison, i.e. without any "consider" options)
/n | don't show initial "Compare" dialog
/sd | always show initial "Compare" dialog, even if two filenames are used
/a:N | scroll through all differences with N second delay and exit after the last difference
/o:file | output diff results into a file 'file' (or to standard output if '-' is specified) and exit
/no | do not generate output file if no diffs are found
/append | append to existing output file (used with /o option; default -- replace existing output file)
/html | output HTML diff report (used with /o option; default -- text diff format; does not work with standard output and/or with /f or /append options)
/p[:printer] | print diff report to default or specified printer and exit
/c | print file diffs when printing directory diff report
/x | read-only mode
/g:file | load ExamDiff Pro options from an options file
/ff | force initial file comparison dialog
/fd | force initial directory comparison dialog
/swap | swap first and second file/directory
/sn1:file | use this name when you save the first file
/sn2:file | use this name when you save the second file
/nh | do not add files or directories to comparison history
/dn1:name | use this as the first file/directory caption
/dn2:name | use this as the second file/directory caption
/?,/h | print this screen

Return Value

0 | if files/directories are identical
1 | if files/directories are different
2 | if an error occurred

Remarks

  • Options may be entered before or after names of files or directories. Use // to specify that no more options will be entered in command line.
  • If only /se:Session is specified, session's file/directory names and options will be used, even if some other options are also specified (they will be ignored.)
    If the /se:Session option is specified along with file/directory names, specified names will be used, along with the options from the session (even if other options are specified in command line).
    If no session is specified, the unnamed default session will be used.
  • If /sf:SessionFile is specified, the session file's file/directory names and options will be used, even if some other options are also specified (they will be ignored.)
  • Options /i, /w, /b, /l, /e, /k, /j, /br, /d, /s, /y, /u, /z, /dc, /dv and /c can be used with "!", in which case the option will be negated (e.g. /!i means do not ignore case).
    If options /i, /w, /b, /l, /e, /k, /j, /br, /d, /s, /y, /u, /z, /dc, /dv, /c (or their negations), /t, tb, /r0, /r1, /r2, /fi, or /fx are not set, the last used options in the specified or default session remain in effect.
  • Command line options are in effect only for the duration of the current comparison. If the Options dialog is invoked, matching command line options will used to initialize the dialog.

Examples

  • ExamDiff c:\temp\a.txt c:\temp\b.txt /o:-
  • ExamDiff c:\temp\dir1 c:\temp\dir2 /d /fi:*.txt
  • ExamDiff c:\temp\dir1 c:\temp\dir2 /se:Unicode
  • ExamDiff // -a.txt -b.txt


Files/Directories Menu Commands

  • Common commands for text and binary file, and directory comparison
    • Compare new pair of files/directories
    • Re-compare files/directories
    • Swap files/directories
    • Up one level for both files/directories
    • Create directory snapshot
    • Report
      • Save HTML diff report
      • View HTML diff report
    • Page setup
    • Print preview
    • Print diff report
    • Exit

  • For text file comparison
    • Toggle text/binary comparison
    • Close files
    • Save
      • Save first/second file
      • Save both files
      • Save first/second file as
    • Compare Selected Fragments
    • View/edit first/second file
    • Report
      • Save Unix diff file
      • View Unix diff File

  • For binary file comparison
    • Toggle text/binary comparison
    • Report
      • Save differences in file
      • View diff file

  • For directory comparison
    • Snapshot
      • Save snapshot of first/second directory
      • Refresh snapshot of first/second directory
    • Compare matched files/directories
    • Compare selected files/directories
    • Perform full file comparison
    • View/edit file
    • Report
      • Save differences in file
      • View diff file


Compare New Pair of Files/Directories

Default Shortcut

CTRL + E

Toolbar Button

Compare New Pair of Files/Directories toolbar button

Spawn a dialog box to select files and directories to compare.

This dialog box has many convenient features. The two combo boxes hold names and paths of files and directories previously compared. You can drag-and-drop files and directories from Windows Explorer into the dialog box making it much easier to enter the appropriate paths and file names. You can also browse for files and directories using the browse buttons.

The Compare dialog also has an Autopick feature: whenever you choose a file (or directory) that you have compared before as the first item to compare, the second item automatically changes to the last one you compared the first item to. For example, if you compare test1 to test2, then the next time you choose test1 as the first file, ExamDiff Pro will remember and automatically switch the second file to test2.

If you don't specify one file's directory, ExamDiff Pro will use the other file's directory to start a comparison. For example, selecting c:\test\a.txt and b.txt will compare c:\test\a.txt with c:\test\b.txt. If a directory name is provided instead of a file name, ExamDiff Pro will use the other file name. E.g., you can select c:\test\a.txt and c:\test2 (where c:\test2 is a directory), and the software will compare c:\test\a.txt with c:\test2\a.txt.

To delete a file/directory name from a list, highlight it and press Delete. This feature also applies to all other combo-boxes within ExamDiff Pro.

When specifying a file or directory, you can use an environment variable, such as %WINDIR%.

For file comparison, the current Clipboard contents can be selected by using an appropriate button to the right from the file name text field. This will make ExamDiff Pro compare a file against Clipboard contents, or compare two Clipboard fragments (if you select a text fragment to Clipboard, then press the first Clipboard button (or use Ctrl + 1 keys), then select another text fragment, then press the second Clipboard button (or use Ctrl + 2 keys)). Also, browsing for a file in file comparison mode allows you to select the encoding to open the file with (ANSI, Unicode (little or big endian), or UTF-8)), as well as choosing a comparison plug-in that will be used for the file during its comparison.

For directory comparison, a snapshot file, archive, or other file can be specified instead of a real directory. Note that in order to compare files other than snapshots against directories, a conversion plug-in is needed (the default installation of ExamDiff Pro includes ZIP and JAR/WAR/EAR extracting plugins). Note also that all directory editing features (delete, rename etc.) will be disabled if at least one of compared directories is a snapshot.

File/directory names can be prefixed by plug-in names followed by > separator (such plug-ins are referred to as inline plug-ins). The plug-in name has to be one of those listed in Plug-in Options. For example, assuming that Sort is the name of a plug-in, the following name will cause the Sort plug-in to be used for file list.txt: Sort>list.txt. Also note that when inline plug-ins are used, file/directory names are not inspected for existence.

The following commands are available in the Compare dialog:
  • Compare
    Compare selected files or directories.

  • Cancel
    Open ExamDiff Pro with empty text file panes (when the program is just started), or close the dialog box without comparison (when the Compare dialog is launched after a comparison). The former is useful to compare two text fragments by either typing text or pasting it into ExamDiff Pro editable text panes.

  • Options
    Change comparison options. If sessions (see below) are used, options saved will be applied to the selected session.

  • Swap
    Swap files or directories selected for comparison.

  • Exit
    Exit without comparison.

If the Show sessions option is disabled, the unnamed default session will be used.

If the Show sessions option is enabled, the session combo box that contains auto sessions becomes visible. The following session management commands are available (when the arrow button on the right of the combo box is clicked; for modified session the arrow becomes red):

  • New Session
    Create a new session, optionally by cloning an existing one.

  • Save Session
    Sessions are saved whenever the Compare button on the Compare Dialog is used. Alternatively, you can use this command to save the current session without comparison, and move on to modifying another session.

  • Delete Session
    Delete the selected session.

  • Rename Session
    Rename the selected session.

  • Copy Session
    Copy one session to another.

  • Save Session to File
    Save the selected session to a session file.

  • Load Session From File
    Load a session from a session file and set it as the current session.


Re-Compare Files/Directories

Default Shortcut
CTRL + R

Toolbar Button

Re-Compare Files/Directories toolbar button

Prompt ExamDiff Pro to re-compare the two files or directories currently being compared. This command is useful when a change to one of the files or directories has occurred outside of ExamDiff Pro. It also is used to compare text files after making modifications to them within the program.

Recomparisons can be undone and redone using the Undo and Redo functions, as long as no options were changed prior to recomparison.


Toggle Text/Binary Comparison

Default Shortcut
CTRL + Q

Toolbar Button

Toggle Text/Binary Comparison toolbar button

Compare the current files in binary comparison mode (if the files are compared in text mode) or vice versa. For persistent mode change use Force text/binary file comparison in Compare Options


Close Files

Default Shortcut
CTRL + L

Close both files. You will be prompted to save the files if they were modified.


Swap Files/Directories

Default Shortcut
CTRL + T

Toolbar Button

Swap Files/Directories toolbar button

Make the file or directory on the left (or top) be the file on the right (or bottom) and the second file on the left (or top). ExamDiff Pro re-compares the files in their new positions.


Up One Level for Both Files/Directories

Default Shortcut
CTRL + U

Toolbar Button

Up One Level for Both Files/Directories toolbar button

Go up to the higher level on the directory tree structure for both files/directories (in case of files, their directories will be compared). Then, compare the two "new" directories. This command allows the user to more quickly navigate and compare the directory tree.


Load Session From File

Load a session from a session file, set it as the current session, and start a comparison.


Save Session To File

Save the current session to a session file.


Recent Session Files

Shows the last four (by default, number can be changed in Options | Global) session files used. When any of these session files is clicked, it is loaded, and a new comparison is launched.


Recent Sessions

Shows the last four (by default, number can be changed in Options | Global) auto session used. When any of these sessions is clicked, it is loaded, and a new comparison is launched.


Save First/Second File

Default Shortcuts
CTRL + F11 and CTRL + F12

Toolbar Buttons

Save First File toolbar button Save Second File toolbar button

Save the first/second file with the same name as before.


Save Both Files

Default Shortcut
CTRL + SHIFT + S

Toolbar Button

Save Both Files toolbar button

Save both files with the same names as before.


Save First/Second File As

Save the first/second file with a new name. You can choose to save the file into a different encoding (ANSI, Unicode (little or big endian), or UTF-8).


Create Snapshot

Default Shortcut
CTRL + N

Toolbar Button

Create Snapshot toolbar button

Creates a snapshot of an arbitrary directory.

Create Snapshot dialog

Snapshots may optionally contain CRCs of files and/or versions of executable files and DLLs, by selecting the appropriate options in the Save As dialog that follows clicking on the OK button. Note the choosing these options will slow down creation of a snapshot.


Compare Selected Fragments

Toolbar Button

Compare Selected Fragments toolbar button

Spawn a new instance of ExamDiff Pro with comparison of the currently selected text fragments in the first and second files. This command is only enabled if you selected text in both files.


View/Edit File

Default Shortcuts
CTRL + SHIFT + 1 and CTRL + SHIFT + 2

Toolbar Buttons

View/Edit First File toolbar button View/Edit First File toolbar button

Spawn an external program, usually an editor, specified in the External editor field. Using this external editor, the user may then modify the file, save the modifications to the file, and then use ExamDiff Pro to re-compare the two files again.


Save Unix Diff File

Default Shortcut
CTRL + S

Toolbar Button

Save Unix Diff File toolbar button

Save the difference between the two files in the standard UNIX Diff format. After the diff report is saved, a dialog will ask you if you want to view it.


View Unix Diff File

Toolbar Button

View Unix Diff File toolbar button

View the difference between the two files in the standard UNIX Diff format, without saving the diff file.


Save HTML Diff Report

Default Shortcut
CTRL + M

Toolbar Button

Save HTML Diff Report toolbar button

Save the comparison results in an HTML file. The resulting HTML file will look very similar to the ExamDiff Pro view (view filters will be used if they are enabled), except that editing will obviously not be possible. You may need the latest version of your favorite browser (Internet Explorer, Mozilla, or Opera), or at least a version with a good support of CSS, Level 1, to view the HTML diff report. After the HTML diff report is saved, a dialog will ask you if you want to view it.

Note: HTML report templates (difftempl_v.htm for vertically split reports, and difftempl_h.htm for horizontally split reports) are located in the ExamDiff Pro program directory. These files are used to generate HTM reports, and can be customized by advanced users to change the look of diff reports.


View HTML Diff Report

Toolbar Button

View HTML Diff Report toolbar button

View an HTML diff report in the default browser. Please note that the latest version of a browser (Internet Explorer, Mozilla, Opera are supported), or at least a version with a good support of CSS, Level 1 may be required in order to successfully view the HTML diff report.


Page Setup

Toolbar Button

Page Setup toolbar button

Spawn a dialog box to set up page properties for printing.

Page Setup dialog

Dialog Box Options

Paper (Size and Source)
Set the preferred paper source of the printer and the appropriate size of paper.

Header (Date Printed and Page Number)
Choose whether to print the current date and/or the page number on the ExamDiff Pro report.

Footer (Legend)
Choose whether to include a legend denoting the colors and patterns used to distinguish various differences.

Misc (No Background)
Check this option if you want no colored background to be printed.

Orientation
Choose the preferred orientation of the paper.

Margins
Set the preferred margins for the report.


Print Preview

Toolbar Button

Print Preview toolbar button

Provide a visual representation of the ExamDiff Pro report's layout as it would appear when printed. This command allows the user to zoom in/out, look at various pages, and print an ExamDiff Pro report.


Print Diff Report

Default Shortcut
CTRL + P

Toolbar Button

Print Diff Report toolbar button

Send an ExamDiff Pro report to the printer. The layout may be previewed using the Print Preview command and modified using the Page Setup command.


Exit

Toolbar Button

Exit toolbar button

Exit ExamDiff Pro.


Edit Menu Commands

  • Common commands for text and binary file comparison
    • Copy
    • Select all
    • Copy block to clipboard

  • For text file comparison
    • Undo
    • Redo
    • Cut
    • Copy with padding lines
    • Paste
    • Delete
    • Delete block
    • Replace block in the second file from second
    • Replace block in the first file from second
    • Add block from first file to second
    • Add block from second file to first

  • For directory comparison
    • Copy to clipboard
    • Copy to third directory
    • Copy as text
    • Delete
    • Delete permanently
    • Delete in both panes
    • Rename
    • Touch
    • Copy from first to second directory
    • Copy from second to first directory


Undo

Default Shortcut
CTRL + Z

Toolbar Button

Undo toolbar button

Undo the last file editing action or recomparison. This command is global, and affects both files.


Redo

Default Shortcut
CTRL + Y

Toolbar Button

Redo toolbar button

Redo the previously undone action or recomparison. This command is global, and affects both files.


Cut

Default Shortcut
CTRL + X

Toolbar Button

Cut toolbar button

Cut the selection and put it on the Clipboard.


Copy

Default Shortcut
CTRL + C

Toolbar Button

Copy toolbar button

Copy the selection and put it on the Clipboard.


Copy with Padding Lines

Copy the selection with padding lines (lines inserted by ExamDiff Pro to align files) and put it on the Clipboard.


Paste

Default Shortcut
CTRL + V

Toolbar Button

Paste toolbar button

Insert the Clipboard contents at the cursor location.


Delete

Default Shortcut
DEL

Toolbar Button

Delete toolbar button

Delete the selection.


Select All

Default Shortcut
CTRL + A

Select the entire document (for a file) or all directory items (for a directory).


Delete Block

Default Shortcut
CTRL + SHIFT + DEL

Delete the current difference. Note that this operation is disabled after manual modifications to either file.


Copy Block to Clipboard

Copy the current difference to the clipboard.


Replace Block in Second File from First

Default Shortcut
CTRL + F9

Toolbar Button

Replace Block in Second File from First dialog button

Copy the current difference from the first to the second file, replacing the difference in the second file. Note that this operation is disabled if the files are out-of-sync due to manual addition or deletion of lines in either file, or if editing is disabled for any other reason.


Replace Block in First File from Second

Default Shortcut
CTRL + F10

Toolbar Button

Replace Block in First File from Second toolbar button

Copy current difference from the second to the first file, replacing the difference in the first file. Note that this operation is disabled if the files are out-of-sync due to manual addition or deletion of lines in either file, or if editing is disabled for any other reason.


Add Block from First File to Second

Default Shortcut
CTRL + SHIFT + F9

Toolbar Button

Add Block from First File to Second toolbar button

Copy the current difference from the first to the second file, keeping the difference in the second file. Note that this operation is only enabled if the status of the difference is CHANGED, and is disabled if the files are out-of-sync due to manual addition or deletion of lines in either file, or if editing is disabled for any other reason.


Add Block from Second File to First

Default Shortcut
CTRL + SHIFT + F10

Toolbar Button

Add Block from Second File to First toolbar button

Copy the current difference from the second to the first file, keeping the difference in the second file. Note that this operation is only enabled if the status of the difference is CHANGED, and is disabled if the files are out-of-sync due to manual addition or deletion of lines in either file, or if editing is disabled for any other reason.


View Menu Commands

The View menu offers the following commands:

  • Common commands
    • Show only first file/directory
    • Show only second file/directory
    • Show both files/directories
    • Toggle splitter orientation
    • Center splitter
    • Use view filter
    • Toggle Ignore the ignores
    • Options
    • Toolbar
      • Show
      • Customize
      • Reset to default
    • Show diff combo box bar
  • For text file comparison
    • Synchronizing splitter
    • Enable word wrap
    • View line numbers
    • View whitespace


Show Only First File/Directory

Default Shortcut
CTRL + 1

Toolbar Button

Show Only First File/Directory toolbar button

Have ExamDiff Pro display only the first file/directory in its display window. This command is useful when not all of the width of the file/directory is visible in the two-pane view.


Show Only Second File/Directory

Default Shortcut
CTRL + 2

Toolbar Button

Show Only Second File/Directory toolbar button

Have ExamDiff Pro display only the second file/directory in its display window. This command is useful when not all of the width of the file/directory is visible in the two-pane view.


Show Both Files/Directories

Default Shortcut
CTRL + B

Toolbar Button

Show Both Files/Directories toolbar button

Have ExamDiff Pro display both the first and the second files/directories in its display window. This command is useful when it is important to see the differences from the perspectives of both files/directories.


Toggle Splitter Orientation

Default Shortcut
CTRL + O

Toolbar Button

Toggle Splitter Orientation toolbar button

Change the two-pane view's separator orientation from left/right to top/bottom and vice-versa. For the case of both files/directories visible, this command is useful when the width of the files/directories is longer than the width of a pane.


Center Splitter

Default Shortcut
CTRL + F8

Toolbar Button

Center Splitter toolbar button

This command will re-center the splitter so that both files/directories have the same amount of visible area in the window.


Synchronizing Splitter

Toolbar Button

Synchronizing Splitter toolbar button

When this option is enabled, the normal splitter is replaced with a wider splitter, on which manual synchronization links can be made.


Use View Filter

Default Shortcut
CTRL + D

Toolbar Button

Use View Filter toolbar button

This command will enable/disable the view filter. Note that files cannot be edited if some of the lines are filtered out.


Enable Word Wrap

Default Shortcut
CTRL + W

Toolbar Button

Enable Word Wrap toolbar button

Enable/Disable word wrapping. You will need to re-compare files in order to see the result of this option. Note that files cannot be edited if word wrap is enabled.


Toggle Ignore the Ignores

Default Shortcut
CTRL + I

Toolbar Button

Toggle Ignore the Ignores toolbar button

Disable/Enable the Ignore options. Disabling forces the most detailed difference-reporting possible. Thus, this command displays all differences, including white space, case of characters and so on.


View Line Numbers

Toolbar Button

View Line Numbers toolbar button

With this option, you can choose whether or not line numbers are displayed in file comparison.


View Whitespace

Default Shortcut
CTRL + ALT + T

Toolbar Button

View Whitespace toolbar button

When this option is enabled, space and tab characters are visible.


View End-Of-Line Markers

Toolbar Button

View End-Of-Line Markers toolbar button

When this option is enabled, EOL (end-of-line) markers are shown. There are separate EOL characters for carriage return í (early Mac OS), line feed ÷ (Unix and Mac OS X), and carriage return followed by line feed Ã (DOS and Windows).


Use Document Type Settings

Toolbar Button

Use Document Type Settings toolbar button

Use document type settings to display files in text comparison mode, as defined by the document type in use. Note that Ignore Comments is enabled separately, in Compare Options. The settings enabled by this feature are Tab size and Syntax highlighting.


Options

Default Shortcut
CTRL + J

Toolbar Button

Options toolbar button

Spawn the Options dialog box.

All of ExamDiff Pro options are controlled here. If sessions are used, the options shown (and possible saved) belong to the currently selected (if the Options dialog is invoked from the Compare dialog) or used (if the Options dialog is invoked from the View menu) session.

The following commands are available in the Options dialog:

  • Go back one page/Go forward one page
    Use these buttons to move from the present Options page to the previous page or on to the next page.

  • OK
    Save and use specified options.

  • Cancel
    Close the dialog without saving.

  • Export to file
    Export current options to a text file.

  • Import from file
    Import options from a text file. Options can then be inspected in the pages but they are not saved until OK button is pressed.

  • Reset to default
    Reset all session options (not including Global options that apply to all sessions) to the program defaults. Options can then be inspected in the pages but they are not saved until the OK button is pressed. Rather than resetting all options, you can also choose to just reset the options on the current page, by selecting the Reset This Page Only option.

The following option pages are available in the Options dialog (note that all options except those under Global apply to the current session):

  • Compare
    • General
    • Advanced
  • Document Types
  • Display
    • General
    • Colors
    • View Filter
    • Dir Columns
  • Misc
    • General
    • Messages
  • Dir Comparison
    • Dir Comparison
    • More
  • Word Wrap
  • File Editing
  • Plug-ins
  • Binary
  • HTML
  • Global
    • General
    • Keyboard


Show Toolbar

Show or hide the toolbar.


Customize Toolbar

Customize Toolbar dialog

Bring up the toolbar customization dialog box. Please note:

  1. Customization is also accessible via mouse right click on a toolbar.
  2. You can also move buttons by holding Alt key and dragging buttons in toolbar.
  3. There are three toolbars in the program: for text file comparison, for binary file comparison, and for directory comparison. Only one (currently active) can be customized at any given time.
  4. The Customize dialog also lets you choose whether the current toolbar should have small (16x16) or large (24x24) icons, and whether or not the icons should have text labels.
  5. If the Re-Compare button shows a little light in it (meaning that one of compared items was modified outside of ExamDiff Pro), you need to re-compare files/directories first in order make toolbar customization possible.


Reset Toolbar to Default

Reset the toolbar to the program default.


Show Diff Combo Box Bar

Show or hide the top dialog bar that contains the differences combo box.


Navigation Menu Commands

The Navigation menu offers the following commands:

  • Common commands for text and binary file, and directory comparison
    • Previous difference
    • Current difference
    • Next difference

  • For text file comparison only
    • Previous difference in line
    • Next difference in line
    • Go to line
    • Bookmarks
      • Toggle bookmark
      • Next bookmark
      • Previous bookmark
      • Clear all bookmarks

  • For binary file comparison only
    • Go to address


Previous Difference

Default Shortcut
SHIFT + F7

Toolbar Button

Previous Difference toolbar button

Scroll the panes to make visible the difference that precedes the current difference.


Current Difference

Default Shortcut
CTRL + F7

Toolbar Button

Current Difference toolbar button

Re-center the panes to the difference currently in focus. This command is very useful when you scroll off the current difference and wish to quickly return to it. The Current Difference changes automatically following cursor movement.


Next Difference

Default Shortcut
F7

Toolbar Button

Next Difference toolbar button

Scroll the panes to make visible the difference that follows the current difference.


Previous Difference in Line

Default Shortcut
SHIFT + F6

Toolbar Button

Previous Difference in Line toolbar button

Move the cursor to the inline difference that precedes the current cursor position. To enable this command, place the cursor in a line with different words or characters (you need to use Lines and words or Lines and characters detail level in Compare Options ) This command will stay disabled if there is no previous inline difference.


Next Difference in Line

Default Shortcut
F6

Toolbar Button

Next Difference in Line toolbar button

Move the cursor to the inline difference that follows the current cursor position. To enable this command, place the cursor in a line with different words or characters (you need to use Lines and words or Lines and characters detail level in Compare Options ) This command will stay disabled if there is no next inline difference.


Go to Line

Move Cursor to Line

Default Shortcut
CTRL + G

Toolbar Button

Move Cursor to Line toolbar button

Bring up a dialog to move the cursor to an arbitrary line in a file.

Move Cursor to Line dialog

Dialog Box Options

Line number
Destination line number. Note that line numbers are “real”, not including extra lines inserted in order to synchronize two files (real line numbers are shown when option “Show line numbers” is enabled).

OK
Jump to the desired address.

Cancel
Close the dialog.


Move Cursor to Current Difference

Moves the cursor to the first line of the current difference.


Toggle Bookmark

Default Shortcut
CTRL + F2

Toolbar Button

Toggle Bookmark toolbar button

Toggle a bookmark for the current line.


Next Bookmark

Default Shortcut
F2

Toolbar Button

Next Bookmark toolbar button

Move to the line containing the next bookmark.


Previous Bookmark

Default Shortcut
SHIFT + F2

Toolbar Button

Previous Bookmark toolbar button

Move to the line containing the previous bookmark.


Clear All Bookmarks

Default Shortcut
CTRL + SHIFT + F2

Toolbar Button

Clear All Bookmarks toolbar button

Clear all bookmarks in the current pane.


Search Menu Commands

The Search menu offers the following commands:

  • Find
  • Find next
  • Find previous
  • Replace (for text file comparison only)


Find

Default Shortcut
CTRL + F

Toolbar Button

Find toolbar button

Spawn a dialog box to perform a search in the pane currently in focus.

Dialog Box Options

Find what
Enter text to search for.

Match case
Find only text having the given pattern of uppercase and lowercase letters.

Match whole word only
Find only occurrences of the text as a whole word.

Regular Expression
In text file comparison panes, you can use regular expressions to specify a search string.

Wrap search
Continue searching after reaching the top or the bottom (depending on the search direction).

Direction
Specify whether you wish to search up or down from the current cursor position.

Find Next
Begin the Find operation.

Bookmark All
Place a bookmark on all lines that contain matching text (this command is available only for text file comparison).

Cancel
Close the dialog.


Find Next

Default Shortcut
F3

Toolbar Button

Find Next toolbar button

Find the next match specified by the Find dialog box in the pane currently in focus.


Find Previous

Default Shortcut
SHIFT + F3

Toolbar Button

Find Previous toolbar button

Find the previous match specified by the Find dialog box for the pane currently in focus.


Replace

Default Shortcut
CTRL + H

Toolbar Button

Replace toolbar button

Spawn a dialog box to perform a text replace for the pane currently in focus.

Dialog Box Options

Find what
Enter text to search for.

Replace with
Enter text to replace the found text with.

Match case
Find only text having the given pattern of uppercase and lowercase letters.

Match whole word only
Find only occurrences of the text as a whole word.

Regular Expression
In text file comparison panes, you can use regular expressions to specify a search string.

Wrap search
Continue searching after reaching the top or the bottom.

Replace In
Specify whether you wish to replace text in the whole file or only in the current selection.

Find Next
Find the next occurrence of the search string.

Replace
Replace the currently selected string that matches the Find What text with the text specified in the Replace With box. If nothing is selected, or if the current selection does not match the Find What text, this button works like the Find Next button.

Replace All
Replace all strings that match the Find What text with the text specified in the Replace With box.

Cancel
Close the dialog.


Help Menu Commands

The Help menu offers the following commands:

  • Help
  • Ordering information
  • Order online
  • ExamDiff Pro on the Web
  • About ExamDiff Pro


Help

Default Shortcut
F1

Toolbar Button

Help toolbar button

Spawn this help file.


Ordering Information

See how to order ExamDiff Pro.


Order Online

Go to the ExamDiff Pro online ordering web page.


ExamDiff Pro on the Web

Spawn the default web browser and connect to the ExamDiff Pro home page.


Check for Updates

Spawn the default web browser and provide information on available updates for ExamDiff Pro.


About ExamDiff Pro

Toolbar Button

About toolbar button

Spawn a dialog box containing ExamDiff Pro version information, registration information, and a few useful links.

Dialog Box Options

Activate
Spawn a dilaog for entring ExamDiff Pro password.

Copy Reg Info
Use this command to copy registration information to the clipboard.


Save Binary Differences in File

Default Shortcut
CTRL + S

Toolbar Button

Save Binary Differences in File toolbar button

Save the difference between the two binary files to a file.


View Binary Diff File

View the difference between the two binary files without saving.


Go to Address

Move Cursor to Address

Default Shortcut
CTRL + G

Toolbar Button

Move Cursor to Address toolbar button

Bring up a dialog to move the cursor to an arbitrary address in a binary file.

Move Cursor to Address dialog

Dialog Box Options

Offset
Relative destination address. Note that addresses are “real”, not including extra bytes inserted in order to synchronize two files (real addresses are shown in the status bars of each pane).

Relative to
Specify whether the address is relative to either the beginning of file, or to the current cursor position, or to the end of file.

OK
Jump to the desired address.

Cancel
Close the dialog.


Save Snapshot of First/Second Directory

Default Shortcuts
CTRL + F11 and CTRL + F12

Toolbar Buttons

Save Snapshot of First Directory toolbar button Save Snapshot of Second Directory toolbar button

Save a snapshot of the first/second directory into a user-specified XML file. Snapshots may optionally contain CRCs of files and/or versions of executable files and DLLs (but choosing these options will slow down creation of a snapshot).


Refresh Snapshot of First/Second Directory

Toolbar Buttons

Refresh Snapshot of First Directory toolbar button Refresh Snapshot of Second Directory toolbar button

Refresh a snapshot of the first/second directory by updating the contents of the snapshot file.


Save Differences in File

Default Shortcut
CTRL + S

Toolbar Button

Save Differences in File toolbar button

Save the difference between the two directories to a file.


View Diff File

View the difference between the two directories without saving.


Compare Matched Files/Directories

Toolbar Button

Compare Matched Files/Directories toolbar button

Compare the selected file/directory with the matched file/directory in the other pane. This option will spawn a new comparison window if the Run new instance of the program to compare from directory panes option is checked. Otherwise, the new comparison is made in the original window.


Compare Selected Files/Directories

Toolbar Button

Compare Selected Files/Directories toolbar button

Compare the selected file/directory with the selected file/directory in the other pane. This option will spawn a new comparison window if the Run new instance of the program to compare from directory panes option is checked. Otherwise, the new comparison is made in the original window.


Perform Full File Comparison

Performs full file comparison on the selected files (and their matching files in the opposite pane). This option cannot be performed on directories, and is disabled if the Full file comparison option is already in use.


Copy to Clipboard

Default Shortcut
CTRL + C

Toolbar Button

Copy to Clipboard dialog button

Copy the selected files or directories to the Clipboard.


Copy to Third Directory

Copy the selected files or directories to a user-specified directory while preserving the relative directory structure of the source items.


Copy as Text

Default Shortcut
CTRL + SHIFT + C

Copy the selected files or directories to the Clipboard as a tab-delimited list of columns.


Delete File/Directory

Default Shortcut
DEL

Toolbar Button

Delete File/Directory toolbar button

Delete the selected files or directories. Undo is available via the Recycle Bin.


Delete Permanently

Default Shortcut
SHIFT + DEL

Toolbar Button

Delete Permanently toolbar button

Delete the selected files or directories permanently (no Undo is available).


Delete in Both Panes

Delete the selected files or directories, along with the matching items in the opposite pane. Undo is available via the Recycle Bin.


Rename File/Directory

Default Shortcut
F2

Toolbar Button

Rename File/Directory toolbar button

Rename the selected file or directory.


Touch File/Directory

Toolbar Button

Touch File/Directory toolbar button

"Touch" the selected file/directories. The touch command sets the time of last file/directory modification to the current time. If a directory is selected, the program will optionally allow you to recursively touch each of its files/subdirectories.


Copy from First to Second Directory

Default Shortcut
CTRL + F9

Toolbar Button

Copy from First to Second Directory toolbar button

Copy the files/directories selected in the first directory to the second directory. This command will overwrite files/directories with the same names in the second directory if they already exist. If directories are copied, all their files/directories will be copied. Note that this command is disabled if the Allow to copy files TO and FROM in directory comparison option in Directory Comparison Options is not selected, and the currently active directory pane is the second pane.


Copy from Second to First Directory

Default Shortcut
CTRL + F10

Toolbar Button

Copy from Second to First Directory toolbar button

Copy the files/directories with the same names as currently selected ones in the first directory from the second directory. This command will overwrite files/directories with the same names in the second directory if they already exist. If directories are copied, all their files/directories will be copied. Note that this command is disabled if the Allow to copy files TO and FROM in directory comparison option in Directory Comparison Options is not selected, and the currently active directory pane is the first pane.


Compare Options

Compare - General Options

Compare Options dialog

Dialog Box Options

Ignore
Do not consider these variations as differences. These preferences may be quickly disabled/enabled using the Toggle Ignore the Ignores command.
  • All white space in lines
    Ignore all white space in lines.

  • Changes in the amount of white space in lines
    Ignore changes in the amount of white space in lines.

  • Leading white space in lines
    Ignore leading white space in lines.

  • Trailing white space in lines
    Ignore trailing white space in lines.

  • Case
    Consider upper- and lower-case to be the same.

  • Blank lines
    Ignore changes whose lines are all blank.

  • Comments
    Ignore comments, as defined by the document type in use. Alternatively, you can use the Ignore Comments toolbar button Ignore Comments toolbar button.
  • Linebreak styles
    Ignore linebreak styles: CRLF (DOS/Windows) vs. LF (Unix) vs. CR (Mac).

  • Lines matching regular expression
    Ignore changes whose lines all match a specified regular expression.
Ignore parts of each line
  • Parts matching regular expression
    Ignore, in each line, parts matching a specified regular expression. For instance, specifying //.* as a regular expression will make the program ignore all single-line C++-style comments.

  • Column ranges
    Ignore, in each line, all text in a certain range of columns. Use a comma-separated list of individual ranges, each of which is either a single number or a pair of dash-separated numbers. Examples:
    • 2-7 matches .34567 in 1.34567890ABCDEFGHIJK.
    • [7]-[2],1,4-[10] matches 14567890AEFGHIJ in 1.34567890ABCDEFGHIJK.
    • [m]-n is not a valid string, for any integers m and n.
Force text/binary comparison
  • Auto text/binary
    Allow ExamDiff Pro to determine whether the compared files are text or binary.

  • Treat binary files as text
    Treat of binary files just as if they were pure ASCII files and show the results in text format.

  • Treat text files as binary
    Compare text files as binary and show the results in HEX format.
Detail level for difference identification
View differences down to word or character level. Thus, if one letter is changed in a file, then one can choose whether only the line of the change is identified, the line and the word where the change occurred, or the line and the character where the change occurred. Alternatively, you can use the Detail Level drop-down toolbar button Detail Level toolbar button, which is not shown by default but can be added to the text file comparison toolbar.


Compare - Advanced Options

Compare - Advanced Options dialog

Dialog Box Options

Fuzzy matching
Fuzzy matching enables ExamDiff Pro to intelligently align lines that are similar but not identical. The options in this section control when fuzzy matching is activated and how selective it is.
  • Do not perform fuzzy matching
    Selecting this option always disables fuzzy matching.

  • Always perform fuzzy matching
    Selecting this option always enables fuzzy matching. This option is not recommended if you are comparing huge files, as it can potentially greatly slow down comparison.

  • Perform fuzzy matching only if both files are smaller than
    Selecting this option enables fuzzy matching only if the files compared are both smaller than the specified size (250KB by default).

  • Matching method
    Use this option to control how the matching of similar lines is performed. The default is Characters, and it suitable for most uses. Choose Words if your files have many distinguishable words.

  • Line similarity
    This option determines the percentage similarity that two lines must have in order to be aligned if fuzzy matching is turned on. Keep in mind that if a line has multiple potential matches within a diff block, the match will be selected that maximizes the total similarity of all the fuzzy matches in the block.

    Selecting 100% similarity effectively disables fuzzy matching. Selecting 0% similarity bypasses ExamDiff Pro's comparison algorithm and triggers line-by-line comparison, in which every line is matched to the line at the same position in the opposite file (i.e. line 50 in the first file will match with line 50 in the second file, ignoring their contents.)


Document Types Options

Ignore Comments Options dialog

An Overview of Document Types

This page allows you to define document types and specify special options for document types. There are three types of document types in ExamDiff Pro:

  • System type icon Default/Plain Text is the default document type that is assigned to all files that do not match any other document types. This document type cannot be deleted or renamed, and cannot participate in syntax highlighting.

  • System type icon System types are those types that come preinstalled with ExamDiff Pro. They cannot be deleted or renamed, but can be assigned to different file extensions. These document types can participate in syntax highlighting and comment ignoring.

  • Custom type icon Custom types are those types that are user-created. They are the only types that can be deleted and renamed. These document types can participate in comment ignoring, but cannot participate in syntax highlighting.

Dialog Box Options

List of document types
Contains a list of all document types, and corresponding file extensions.

New
Creates a new blank document type.

Remove
Deletes the selected document type. Only user-created types can be deleted.

Document type details
Contains options specific to each document type:
  • Type name
    The name of the document type. Only user-created types can be renamed.

  • Extensions
    File extensions that the document type applies to.

  • Regular expression for comments
    The regular expression (if any) that defines comments for the document type. This option can be customized for system types as well as custom types, but users should be warned that changing the regular expression for system types does not modify the parsing algorithms used for syntax highlighting, which could lead to a discrepancy between the two. Note that we use the term "comments" in a very broad sense; any single- or multi-line part of a text file can be considered a "comment" as long as it is defined by a regular expression.

    • Single line comments
      Single line comments (such as // in C++), use the following regular expression: [comment symbol].*?\n . For example, the regular expression for C++ style comments is //.*?\n . Note the non-greedy ? operator.

    • Multi-line comments
      Multi-line comments (such as /* */ in C), use the following regular expression: [start comment symbol].*?[end comment symbol] . For example, the regular expression for C-style comments is /\*.*?\*/ . Again, note the non-greedy ? operator.

    • Combining comments
      Different kinds of comments can be combined ("OR-ed") using the | character. For example, the regular expression /\*.*?\*/|//.*?\n ignores both C and C++ style comments.

  • Tab size
    Sets the tab size (that is, the number of spaces in a tab) for the document type. This option only takes effect if Use document type settings is enabled.

  • Participate in ignoring comments
    Ignore the specified comment during comparison. This option only takes effect if Ignore Comments is enabled.

  • Participate in syntax highlighting
    Highlights certain syntax elements during comparison. Diff highlighting takes precedence over syntax highlighting, so syntax highlighting only takes effect on identical blocks. This option can only be enabled for system types, and only takes effect if Use document type settings is enabled.

    If a file belonging to a document type with syntax highlighting enabled is compared to a file or fragment without syntax highlighting, the syntax highlighting (of the file with syntax highlighting) will be applied to both files. After syntax highlighting is applied, note that it can always be changed for each file individually, using the Set syntax highlighting option in the context menu.

  • Syntax colors
    This option is only visible if Participate in syntax highlighting is enabled, and enables you to choose colors for each of the five syntax elements that ExamDiff Pro highlights: keywords, preprocessor commands, comments, operators, and numbers. Note that not all of these elements apply to all document types.

Use the other file's type if a file only matches the Default type
If this option is selected and two files are compared, one of which matches a document type and the other only matches the Default type, then both files will be treated as though they match the document type. This is useful for source control, because source control file versions often have extensions different from the actual source files.


Display - General Options

Display Options dialog

Dialog Box Options

Display
  • Show line numbers
    Select this option if you want to see line numbers in file comparison panes.

  • Show directory listview tooltips
    Select this option if you want to see tooltips in directory comparison panes.

  • Scroll current diff to center
    Select this option if you want the program to scroll panes so that the entire current difference is centered vertically. If that is not possible (because the difference is larger than the pane height), the first line of the difference is scrolled to the [top + 1 line] position.

  • Show color bars
    Select this option if you want to see color bars for graphical presentation of differences and specify the width (in pixels) of the color bars.

  • Use foreground colors for the color bars
    Select this option if you want foreground colors to be used in the color bars. Otherwise, background colors will be used.

  • Show diff bars
    Select this option if you want to see diff bars marking the current difference and specify the width (in pixels) of the bars.

  • Show moved blocks
    Select this option if you want moved blocks to be displayed.

  • Show synchronization buttons in diff bars
    Select this option if you want to see synchronization buttons to be shown in diff bars.

  • Use Windows icons and file types
    Select this option if you want to see file icons and types in directory comparison panes just like you see them in Windows Explorer. Usually works a little slower.

  • Synchronize vertical scrolling
    Select this option if you want to synchronize vertical scrolling of file or directory comparison panes.

    If you hold Alt while scrolling, this feature is temporarily disabled, and the pane will be scrolled independently of the opposite pane. However, once you let go of Alt and begin normal scrolling, the opposite pane will once again be synchronized with the pane that you just scrolled, provided that this option is checked.

    Alternatively, you can use the Synchronize vertical scrolling toolbar button Synchronize vertical scrolling toolbar button, which is not shown by default but can be added to the toolbar.

  • Synchronize horizontal scrolling
    Select this option if you want to synchronize horizontal scrolling of file or directory comparison panes. Hold the Alt key while scrolling to temporarily disable synchronization.

    Alternatively, you can use the Synchronize horizontal scrolling toolbar button Synchronize horizontal scrolling toolbar button, which is not shown by default but can be added to the toolbar.

  • Use document type settings
    Use document type settings to display files in text comparison mode, as defined by the document type in use. Note that Ignore Comments is enabled separately, in Compare Options. The settings enabled by this feature are Tab size and Syntax highlighting.

  • Highlight the line containing the cursor
    Select this option if you want to highlight the line containing the cursor in text file comparison.

  • Show line modification marks
    Select this option if you want to see line modification marks.
Fonts
Change file or directory comparison fonts, font sizes, font styles, etc for screen and printer.


Display - Colors Options

Colors Options dialog

Choose the text and background colors, hatch options, and font effects for all of the difference identification types. For each type, you can also choose to make the effects for that type the same as the effects for identical lines, by checking the Same as identical checkbox. This command can be used to temporarily mask certain difference types.

Note: Ignored line parts are parts of each line, which are excluded from comparison as a result of using Ignore parts of each line options (see Compare Options). Also note that ignored parts are not colored when Word Wrap mode is on.


Display - View Filter Options

View Filter Options toolbar button

Dialog Box Options

File Comparison
  • View identical segments
    Select this option to show identical lines when file view filter is enabled.

  • View changed segments
    Select this option to show changed lines when file view filter is enabled.

  • View added segments
    Select this option to show added lines when file view filter is enabled.

  • View deleted segments
    Select this option to show deleted lines when file view filter is enabled.

  • View moved segments
    Select this option to show moved diff blocks when file view filter is enabled.

  • Number of context lines
    Number of identical lines before and after every difference (for text file comparison only).
Directory Comparison
  • Status filter
    • View identical items
      Select this option to show identical files/directories when directory view filter is enabled.

    • View changed items
      Select this option to show changed files/directories when directory view filter is enabled.

    • View added items
      Select this option to show added files/directories when directory view filter is enabled.

    • View deleted items
      Select this option to show deleted files/directories when directory view filter is enabled.

    • View newer/older items
      Select this option to show newer/older files/directories when directory view filter is enabled.

  • File path filter
    • Use path filter
      Select this option to use file path filter in displaying files/subdirectories.

    • Filters (Include and Exclude Patterns)
      Patterns describing the types of file/directory names to be included/excluded in the comparison. Use the conventional DOS wildcard characters to specify these types. The filters are applied to file/directory names in non-recursive comparison, and to file/directory names prefixed by relative paths in recursive comparison.


Display - Dir Columns Options

Dir Column Options dialog

Dialog Box Options

Visibility and order
This section lets you specify what columns and in what sort order to show in the directory comparison list view. Note that the File Name and Relative Path (if recursive comparison is used) columns are always visible.

Note that in order to see the number of diffs you need to enable Perform full file comparison and disable Do not calculate number of differences in Dir Comparison Options.

Behavior
  • Show relative path
    Select whether to show the Relative Path column in both panes, or only in the first or the second pane.

  • Resize columns synchronously
    If this option is selected, changing a column width in one pane will also change the respective column width in the opposite pane.
Background thread for CRC and version calculations (advanced)
If CRC and/or Version columns are selected, since calculation CRCs (especially for large files) and retrieving version information may be very time-consuming, such calculations are done as a background task (a separate thread) after comparison is finished. In such cases a small progress bar appears in the first pane of the main status bar, and visible files are updated as soon as their CRCs or versions are determined. You can modify the thread priority by selecting one on the combo box values (the default priority is Idle)


Misc - General Options

Misc Options dialog

Dialog Box Options

External editor
  • Command
    Specify an editor to be spawned for text files by the View/Edit File option. To browse for the editor's executable file, use the button with three dots on the right of the Command text box.

  • Arguments
    Specify the command-line arguments to be utilized when spawning a file. The following internal ExamDiff Pro variables can be used to construct arguments (by clicking on the button with triangle):

    • File path surrounded by quotation marks
      Name of the file in the active pane surrounded by quotation marks.

    • File path without quotation marks
      Name of the file in the active pane.

    • Current different line
      Line number of the first line in the current difference.

    • Caret line
      Line number of the caret in the active pane.

    • Caret column
      Column number of the caret in the active pane.
Word separators
  • Any non-alphanumeric character
    Use this option if you want all non-alphanumeric character to be word separators.

  • Any of these characters (use \t for the TAB character)
    Specify custom characters to serve as word separators for both comparison and text navigation. Default separators: SPACE TAB \ / ! . , ; :

  • Ignore word separators embedded in quoted strings during comparison
    If this option is enabled, ExamDiff ignores separators within quoted strings. A quoted string may be enclosed between a pair of single-quotes or double-quotes. Embedded consecutive pairs of same-kind quotes and all other-kind quotes are treated as part of the quoted string. If a quote is unmatched, it is considered to encompass the rest of the line. This option is useful for comparing consistently formatted tabular data such as the output from a Database Management System. Note that separators embedded in quoted strings will only be ignored during comparison, not during word-by-word text navigation, word selection, or search ("Match whole word only").
General
  • Number of recent files/directories
    Maximum number of most recently compared files or directories stored by ExamDiff Pro.

  • Number of recent searches
    Maximum number of most recent strings used in Find and Replace dialogs stored by ExamDiff Pro.

  • Change notifications for file and directory comparison
    Disable, automatically re-compare, or notify the user when a file or directory currently in comparison is modified by another application.

    • Do not monitor
      ExamDiff Pro will not monitor file/directory changes.

    • Monitor
      ExamDiff Pro will monitor file/directory changes and give the following visual cues when changes are made:
      • A balloon message will be shown in the appropriate pane.
      • The Re-Compare button will have a small yellow star on it.
      • The name of the changed file/directory will become underlined, and the title tooltip will provide information about when the file/directory was changed relative to the latest comparison time.
      • In directory comparison, all files and subdirectories that were modified will be italicized.

    • Ask
      ExamDiff Pro will show a message asking to re-compare files/directories.

    • Auto re-compare
      ExamDiff Pro will automatically re-compare files/directories without asking.
After new compare scroll vertically to
Control initial vertical scroll position after new comparison.
  • First difference
    Scroll to the first found difference (if it exists).

  • Top
    Scroll to the top of compared files/directories.
After re-compare scroll vertically to
Control initial vertical scroll position after re-comparison, swapping files, and setting on/off view filters.
  • Previous position
    Scroll to the previous vertical scroll position (if it still exists).

  • Previous difference
    Scroll to the previous difference (if it still exists).

  • First difference
    Scroll to the first found difference (if it exists).

  • Top
    Scroll to the top of compared files/directories.

  • Cursor in active pane
    Scroll to make cursor in the active pane visible. This option is only valid for file (text and binary) comparison, and may be useful when you turn on and off view filters.
After re-compare scroll horizontally to
Control initial horizontal scroll position after re-comparison, swapping files, and setting on/off view filters.
  • Previous position
    Scroll to the previous horizontal scroll position (if it still exists).

  • Beginning
    Scroll to the beginning of compared files/directories.

  • Cursor in active pane
    Scroll to make cursor in the active pane visible (only valid for file comparison).
Compare Dialog always on top
Force the Compare Dialog box to always be on top.

Minimize when "Compare New Pair"
Minimize the comparison window when the Compare New Pair Of Files dialog box is brought up. This feature allows easy access to the rest of the desktop when the dialog box is brought up.

Use View Filter when diff file is saved
Use this option if you want ExamDiff Pro to use View Filter when diff file is saved or viewed. This will allow you to filter information saved into diff file.

Reuse window pos in launched instance
Use the same window position when comparing files/directories from directory comparison panes.

Default print uses selection (if it exists)
If this option is used, when you select Print toolbar button, or Print Preview command (either from the menu or from the toolbar), ExamDiff Pro will print/preview the current selection (if it exists). Otherwise, the whole contents of file/directory panes will be printed/previewed.

Treat Clipboard buffers as initially modified
When this option is used, and Clipboard contents are selected instead of a file, ExamDiff Pro will prompt to save the file when it's closed.

Use Ignored color in diff blocks
When this option is used, Ignored color will be used to display ignored lines and line fragments that are located in diff blocks (of added, deleted, or changed lines).


Misc - Messages Options

Messages Options dialog

Control what messages ExamDiff Pro will show in different situations.

Dialog Box Options

Message about identical text files
Show message that compared text files are identical, instead of always showing files in text file comparison panes.

Message about different text files
Show message that compared text files are different, instead of always showing files in text file comparison panes.

Message about identical binary files
Show message that compared binary files are identical, instead of always showing files in binary file comparison panes.

Message about different binary files
Show message that compared binary files are different, instead of always showing files in binary file comparison panes.

Message about identical directories
Show message that compared directories are identical, instead of always showing directories in directory comparison panes.

Message about different directories
Show message that compared directories are different, instead of always showing directories in directory comparison panes.

Message about identical file/directory names
Show message that compared file/directory names are identical, instead of always showing files/directories in comparison panes.

Warning about losing Undo/Redo after certain actions on modified files
Show warning that all Undo/Redo information will be lost after certain actions.

"Some comparison options have changed" message
Show message after the Options Dialog is closed and some options that may affect comparison results have changed.

Prompt to re-compare when "Use View Filter" command is used
Prompt to re-compare files if "Use View Filter" command is used after one or both files were edited within ExamDiff Pro.

Prompt to re-compare when directory filter is changed
Prompt to re-compare files when filters where changed in the directory comparison context menu.

"No newline at the end of file" message
Show warning if there is no newline character at end of text file.

"Comparison too slow?" balloon message
Show a balloon message with hints on how to make comparison faster if file or directory comparison takes longer than 30 seconds, and there are way to improve the speed.

Regular expression messages during comparison
Show messages generated by the regular expression engine during comparison.

Warning about editing read-only files
Show warning when read-only files are about to be edited within ExamDiff Pro.

Warning about editing files preprocessed by plug-in(s)
Show warning when preprocessed by plug-in(s) files are about to be edited within ExamDiff Pro.

Question about "# Of Diffs" column
Show message about options required to be enabled in order to see the # Of Diffs column.

Invalid manual synchronization links messages
Show messages explaining why created or modified manual synchronization links are invalid.

Plug-in balloon messages
Show balloon messages that provide information about applied or failed plug-ins.

Directory comparison filter balloon messages
Show balloon messages that provide information about directory comparison filters applied during comparison.

Question about viewing diff reports after saving
Prompt to view the saved report file.


Directory Comparison - General Options

Directory Comparison Options dialog

Dialog Box Options

Recursive Comparison
Set the level of recursive comparison. Alternatively, you can use the Recursion drop-down toolbar button [image].
  • Do not compare subdirectories at all
    If this option is selected, ExamDiff Pro will not attempt to compare subdirectories.

  • Compare subdirectories only to determine their status
    If this option is selected, ExamDiff Pro will try to figure out whether contents of two subdirectories differ, and the subdirectories will be marked as identical or different.

  • Compare subdirectories recursively
    If this option is selected, ExamDiff Pro will compare files in subdirectories recursively.
Type of file comparison
Select what type of comparison of matching files should be performed:
  • Perform full file comparison
    If this option is used, ExamDiff Pro will perform full comparison (comparison based on file contents) of matching files in compared directories. This type of file comparison is always slower but is ultimately accurate; also, it will use all file comparison options. To enable or disable this option, you can also use the Full File Comparison toolbar button [image].

  • Consider files with same size and timestamp identical
    Mark files as identical if their sizes and timestamps match exactly.

  • Consider files with same CRC identical
    Mark files as identical if their CRCs are the same.

  • Consider files with different sizes different
    Mark files as different if their sizes differ. While this seems to be natural, if for instance white space is ignored, files of different sizes may still be identical.

  • Consider files with different timestamps different
    Mark files as different if their modification times differ.

  • Consider files with different attributes different
    Mark files as different if any of their attributes (archive, hidden, read-only, system) differ.

  • Consider files with different CRCs different
    Mark files as different if their CRC32 values differ.

  • Consider files with different versions different
    Mark executable and DLL files as different if their file versions differ.
For faster comparison
These options will make directory comparison faster:
  • Do not calculate directory sizes
    If this option is not checked, ExamDiff Pro will recursively calculate the size of all files in each shown directory (for non-recursive subdirectory handling).

  • Do not calculate number of differences
    If this option is not checked, ExamDiff Pro will calculate the number of differences for each file and directory (if Status Only subdirectory handling is used). This calculation will be performed only if Perform full file comparison option is used, and it may significantly slow down directory comparison. For files, number of differing lines will be shown only for changed files.
Initial Sorting
Specify the preference for how ExamDiff Pro should sort the files in the directory when it compares or re-compares directories.


Directory Comparison - Filters Options

Filters Options dialog

Dialog Box Options

Name filters (comma-separated patterns)
Name filters are patterns describing the types of file/directory names to be included/excluded in the comparison. ExamDiff Pro will compare only those files/directories whose names match at least one pattern in the include filter, but do not match any of the patterns in the exclude filters. Pattern in the include and exclude filter must be separated by commas.

You can use the conventional DOS wildcard characters ('?' to match a single character or '*' to match any number of characters) to specify these types. For example, d?n* and *.cpp are acceptable filter types.

By default only names are matched against the filter. In order to match full paths of files/directories, prefix filters with the ‘:’ character (which will be ignored during matching); For instance, a name filter *file* will match against c:\xyz\abc\file1.txt and c:\xyz\abc\file2.txt files, while a path filter :*file* will in addition match against c:\xyz\new_files\abc.txt (note new_files in the path). A common use of path filters is to exclude or include files based on subdirectories they are located in; for this use the form :*\subdir\*.

There are two more special characters that the name filter lists use: '|' and '/'. Filters can be disabled by prefixing them with a '|' character (which will be ignored during matching and must be placed before a ':' character). Use '/' in place of commas in filter names.

The include and exclude filter together make up a filter set. The Manage combobox can be used to select between different preinstalled and user-defined filter sets. The following filter set management commands are available (when the arrow button on the right of the combo box is clicked):
  • Edit Filter
    Launch the Include/Exclude Filters dialog.

  • New Filter
    Create a new filter set, optionally by cloning an existing one.

  • Delete Filter
    Delete the selected filter set.

  • Rename Filter
    Rename the selected filter set.

Date filter
The Date filter, if enabled, compares files only if their Last Modified date falls within the specified limits. The Date filter gives you three options: you can either disable the Date filter, only compare files whose date falls between two set dates, or only compare files that are not older than a certain age.

Size filter
The Size filter, if enabled, compares files only if their size falls between the upper and lower limits. Both the upper and lower limits may be enabled or disabled by checking or unchecking the checkbox next to them, respectively.

Note that date and size filters apply only to files, not to directories, and if a file in one pane is compared, the matching file (if any) in the opposite pane will be compared as well.


Directory Comparison - Other Options

Directory Comparison - Other Options dialog

Dialog Box Options

Misc
  • Time difference to ignore
    If file timestamps differ by less than this number of seconds, the timestamps are considered identical.

  • Time zone / DST difference
    Use this field to specify a time zone or DST difference between two directories. Timestamps of matching files which differ by this offset (+/- time difference in seconds, see previous section) will be considered identical.

  • Print file diffs when printing directory diff report
    Select this option if you want to print diff report for each pair of changed files while printing a directory diff report. Note: this option will not work if you decide to print directory diff report to a file.

  • Show empty directories in recursive comparison
    Select this option if you want to see <Empty directory> pseudo-files in recursive comparison. Operations on these “files” are effectively operations on empty subdirectories in which <Empty directory> pseudo-files are “located”.

  • Run new instance when comparing subdirectories
    Spawn a new ExamDiff Pro window when subdirectories are compared from directory comparison panes using double-clicking, Compare Matched Files/Directories, or Compare Selected Files/Directories commands, without closing the original directory comparison window.

  • Run new instance when comparing files
    Spawn a new ExamDiff Pro window when files are compared from directory comparison panes using double-clicking, Compare Matched Files/Directories, or Compare Selected Files/Directories commands, without closing the original directory comparison window.

  • Allow to copy files TO and FROM in directory comparison
    Select this option if you want ExamDiff Pro to allow copying files or directories to and from directory in the active pane. If this option is not selected, ExamDiff Pro will only allow copying from the active directory, thus making the operation a little safer. This option affects both main directory comparison menu (Edit | Copy from First to Second Directory and Edit | Copy from Second to First Directory commands) and directory comparison context menu (Copy to OTHER Directory and Copy to THIS Directory commands).

  • Process reparse points for subdirectories
    If this option is set, the program will process reparse pints (junctions) by following their links. This option may lead to infinite recursive looping through directories if, for example, a junction point links a directory that is a parent of the junction's own directory.

  • Timestamp copied files with current time
    If this option is set, ExamDiff Pro will set the modified time of all files/directories copied from one pane to another to the current time.
Backup
  • Back up files replaced during Copy operations
    Selecting this option means that whenever you copy (or move) a file from directory A to directory B, if directory B already contains a file with the same filename, the original file will be moved to a backup subdirectory.

  • Subdirectory for backup
    This is the subdirectory, relative to the compared directory, in which backups are stored.

  • Ignore backup subdirectory in comparisons
    Select this option if you don't want the backup subdirectory to be included in comparison.


Word Wrap Options

Word Wrap Options dialog

Dialog Box Options

Enable word wrap
Enable/disable word wrap. Note that files cannot be edited if this option is enabled.

Type of word wrapping
  • Synchronized
    ExamDiff Pro will synchronize lines in the wrapped files. Useful for files with long lines of varying length.

  • Simple
    ExamDiff Pro will not synchronize lines in the wrapped files. Useful for files with fixed line length in which line breaks are missing.
Wrap width
Specify wrap width (maximum number of characters in each line).

  • Use this number
    ExamDiff Pro will set the wrap width to the number selected.

  • Fit to window
    ExamDiff Pro will fit the word wrap to the width of the comparison pane. If the two panes have different width, the smaller pane will be used.
Wrapped line continuation character
This is the character that appears as the line number of a line that is the continuation of a wrapped line (blank by default).


File Editing Options

File Editing Options dialog

Dialog Box Options

Enable editing within ExamDiff Pro
Enable/disable file editing within ExamDiff Pro. Note that file editing is not supported for two modes: Show Differences Only and Word Wrap.

Save files before re-comparison
Automatically save changed files before running re-comparison.

Allow editing read-only files
If this option is not checked, read-only files cannot be edited. Otherwise, they can be edited but not saved (you can only save them with different names or remove read-only attribute, and then save).

Convert tabs to spaces when saving files
When files are saved, tabs will be converted to spaces using Tab size from Display Options.

Smart Home key behavior
Select this option if you want the Home key to alternately move the cursor between the first non-space character and the left margin.

Overwrite files directly during saving
By default, when a file is saved, ExamDiff Pro saves changes to a temporary file, then deletes the original files and renames the temporary file to the original file. While this guarantees that the original file is preserved even if the save operation fails, some file information, such as its attributes, summary, security, and creation information, may be lost (ExamDiff Pro will try to preserve security attributes even when a temporary file is used). If this option is checked, the original file is overwritten directly, which preserves the file information, but the file itself may be corrupted if the save fails. It is recommended that if you use this option, the next option, Create backups before saving files, is also used.

Create backups before saving files
If this option is enabled, ExamDiff Pro will create a backup file every time a file is saved. The backup file naming rule for file FILE.EXT allows you to specify how backup files are named and where they are saved.

After copying block from one file to another
This option controls the current difference position after copying block from one file to another. The current difference may stay where if was, move to the next to difference (if it exists), or move to the previous difference (if it exists). Using this option will allow you to copy block after block without manually advancing to the next or previous difference.


Plug-in Options

Plug-in Options dialog

This page allows you to specify plug-in applications to be used on files before comparing them.

Dialog Box Options

Use Plug-ins in file comparison
Enables/disables the option to use plug-ins during file comparison.

Use Plug-ins in directory comparison
Enables/disables the option to use plug-ins during directory comparison.

Alternatively, you can use the Use Plug-ins toolbar button [image] to enable or disable plug-ins.

List of plug-ins
Contains list of all registered plug-ins. Use checkboxes to enable/disable plug-ins.

New
Opens the Plug-in Details dialog, creating a new plug-in.

Edit
Opens the Plug-in Details dialog, modifying the selected plug-in.

Remove
Deletes the selected plug-in.

Move up
Moves the selected plug-in up in the list.

Move down
Moves the selected plug-in down in the list.

Details
Lists plug-in details. See Plug-in Details for more information.


Binary Options

Binary Options dialog

Dialog Box Options

Comparison
  • Comparison block size
    Minimal difference block size, in bytes. The bigger the number, the faster and less accurate the comparison. The most accurate binary comparison is performed when the block size is 1 byte. However, if you are comparing large files, comparison may take such a long time that it would make sense to sacrifice some precision for better performance.
Number of bytes per line
  • Use this number
    Use the specified number of bytes per line.

  • Fit to window
    Change the number of bytes per line to always fit the current pane width.
Byte format
  • Byte value format
    Specify the byte value format to be used in the left part of binary display.

  • Byte value case
    Specify the byte value case to be used in the left part of binary display. This option Only effects hexadecimal format.
Character set
  • ASCII
    Use the ASCII character set to display byte codes.

  • Show control characters
    Display control characters (with values 1...31) while showing ASCII codes. Otherwise, display the '.' character.

  • Show extended characters
    Display extended characters (with values 128...255) while showing ASCII codes. Otherwise, display the '.' character.

  • EBCDIC
    Use the EBCDIC character set to display byte codes.
External binary editor
  • Command
    Specify an editor to be spawned for binary files by the View/Edit File option. To browse for the editor's executable file, use the button with three dots on the right of the text box.

  • Arguments
    Specify the command-line arguments to be utilized when spawning a file. The following internal ExamDiff Pro variables can be used to construct arguments (by clicking on the button with triangle):

    • File path surrounded by quotation marks
      Name of the file in the active pane surrounded by quotation marks.

    • File path without quotation marks
      Name of the file in the active pane.

    • Caret offset
      Binary address of the caret in the active pane.


HTML Options

HTML Options dialog

Dialog Box Options

HTML template files
  • Vertically split
    Specify an HTML template to be used for HTM diff report generation if the screen is split vertically. To browse for the template file, use the Browse button on the right of the text box.

  • Horizontally split
    Specify an HTML template to be used for HTM diff report generation if the screen is split horizontally. To browse for the template file, use the Browse button on the right of the text box.
Use JavaScript
If this option is set, ExamDiff Pro will use JavaScript to generate HTML reports. Uncheck this option if your browser is set up to not allow JavaScript. If JavaScript is not used, some HTML report features, such as difference navigation and synchronized scrolling, will be lost.


Global - General Options

Global Options dialog

Dialog Box Options

These options apply to all sessions.

Windows Explorer integration
  • Enable Windows Explorer (Shell) integration
    Select this option if you want to have ExamDiff Pro menu items added to file or directory context (right-click) menus in your Windows Explorer. If one file or directory is selected, ExamDiff Pro context menu items will allow you to chose the selected file/directory as the first item for further comparison, to compare it with the previously selected file/directory, or to open ExamDiff Pro and browse for the second file/directory to compare. If two files/directories are selected, you will be able to compare them by using the ExamDiff Pro context menu item with one click.

    In 32-bit systems, ExamDiff Pro installs a 32-bit Shell extension. In 64-bit systems, ExamDiff Pro installs both 32-bit and 64-bit Shell extensions.

  • Allow comparing files to directories (by appending file names to directory names)
    Select this option if you want to be able to compare files to directories (ExamDiff Pro will silently append the file name to the directory name, and then compare the two files).

  • Command line options
    Command line options used for starting ExamDiff Pro from the Shell extension.
Autopick
  • Enable Autopick
    Select this option if you want to enable the Autopick feature: the ability to remember file and directory pairs after they are compared, and to automatically select the second item based on the first one in the Compare dialog. This feature also keeps track of the last time that every pair of files or directories is compared, and displays it in the status bar of the Compare dialog.

  • Maximum number of stored Autopick pairs
    Maximum number of file/directory pairs stored by ExamDiff Pro.
Sessions
  • Number of recent sessions
    Sets the number of recent sessions displayed in Files/Directories | Sessions menu.

  • Number of recent session files
    Sets the number of recent session files displayed in Files/Directories | Sessions menu.

  • Retain file/directory pair when changing session
    Select this option if you want the file/directory pair to be retained when you change sessions in the Compare dialog. When this option is disabled, as it is by default, the file/directory pair changes to the most recent pair of the session that you select.


Global - Keyboard Options

Keyboard Options dialog

This page allows you to change default assignment of keyboard shortcuts to ExamDiff Pro commands. As with other global options, Keyboard settings affect all comparison sessions.

Dialog Box Options

Comparison mode
Contains list of three ExamDiff Pro comparison modes. Commands that are specific to comparison modes may have the same keyboard shortcut without any conflict. However, if a command is common for two or all three modes, such as Exit command, changing it will affect all modes the command belongs to.

Category
Contains list of categories for the current comparison mode. Categories map to the mode menu.

Commands
Contains list of commands that belong to the selected category. Commands generally come from the menu corresponding to the category, but sometimes they come from the context menu, or not from any menu. “All commands” category contains all commands for the selected comparison mode.

Current keys
Lists keys currently assigned to the selected command (if such assignments exist). If a key is locked (cannot be removed), it is shown in gray text color. If multiple keys are shown, each of them will be used to execute the command.

Description
Contains description of the selected command.

Press new shortcut key
This control allows you to specify a new shortcut for the selected command. In order to do so, click mouse inside the control, then press a desired key or key combination.

Currently assigned to
If the key that you pressed is already assigned to some other command within the current comparison mode, or within any other mode where the currently selected command exists, this control will list such commands along with the comparison modes they belong to. It will also indicate whether the shortcut is locked.

Assign
If the key you pressed is not assigned to any other command, this button will allow you to assign the key to the current command, after which the key will be added to the Current keys list.

Remove
Use this button to remove the key assignment, selected in the Current keys list, from the current command. The button is disabled if the key is locked.

Move Up
Use this button to move a key up in the Current keys list. The top key is shown in the menus and tooltips for the selected command. There are no other differences between multiple keys assigned to a command.

Move Down
Use this button to move a key down in the Current keys list.

Reset to default
Reset all key assignments to the program defaults. New assignments can then be inspected in the Keyboard Options page but they are not saved until OK button is pressed.


End-User License Agreement

IMPORTANT -- Read these terms carefully before installing this software. By installing or using this software, you acknowledge that you have read this license agreement, that you understand it, and that you agree to be bound by its terms. If you do not agree to the terms and conditions of this license agreement, promptly exit the installer without installing the software. Your installation of the software is a symbol of your signature that you accept the terms of this end user license agreement.

This is not free software. Permission to use or evaluate this software is hereby granted for 30 days starting the first day of use. You may freely and legally use or evaluate this software for 30 days without any obligation. Using this software beyond the above granted period requires purchasing a license. Unregistered use of the software after the 30-day evaluation period is in violation of U.S. and international copyright laws.

1. GENERAL

This License Agreement shall constitute the entire Agreement between the parties hereto. Any waiver or modification of this License Agreement shall only be effective if it is in writing and signed by both parties hereto. If any part of this License Agreement is found invalid or unenforceable by a court of competent jurisdiction, the remainder of this License Agreement shall be interpreted so as to reasonably effect the intention of the parties.

2. GRANT OF LICENSE FOR REGISTERED USERS

2.1. SINGLE-SEAT LICENSE

If you purchased a single license of the software with which this license is distributed ("ExamDiff Pro"), PrestoSoft LLC grants you a non-exclusive, non-transferable license to install and use the Software, including any documentation files accompanying the Software, on any number of personal computers, as long as the Software is used only by the individual for whom the license was purchased.

2.2. MULTI-SEAT LICENSES

If you purchased multiple licenses of the Software, PrestoSoft LLC grants you a non-exclusive, non-transferable license to install and use the Software, including any documentation files accompanying the Software, on up to as many personal computers as you have licenses. For example, if you have five licenses of the Software, you can install it on up to five personal computers. If the Software is installed on a single computer and is accessed through a network, the number of computers in can be used from must not exceed the number of purchased licenses.

2.3. GENERAL

In all cases, the license is granted to you only provided that: (i) all copyright notices are maintained on the Software; (ii) the Software and Documentation only for your own personal or internal business use and not in the operation of a service bureau or for the benefit of any other person or entity; and (iii) you agree to be bound by the terms of this License Agreement.

3. OWNERSHIP

You have no ownership rights in the Software. Rather, you have a license to use the Software as long as this License Agreement remains in full force and effect. Ownership of the Software, Documentation and all intellectual property rights therein shall remain at all times with PrestoSoft LLC. Any other use of the Software by any person, business, corporation, government organization or any other entity is strictly forbidden and is a violation of this License Agreement.

4. COPYRIGHT

The Software and Documentation contain material that is protected by United States Copyright Law and trade secret law, and by international treaty provisions. All rights not granted to you herein are expressly reserved by PrestoSoft LLC. You may not remove any proprietary notice of PrestoSoft LLC from any copy of the Software or Documentation.

5. DISTRIBUTION

The Software may be distributed free of charge as the original compressed evaluation release file without any modification. Any modification of this file without prior authorization of the author is a copyright violation. Anyone wishing to charge people a fee for giving them a copy of the Software must have the written authorization of the author, without which, the distributor is guilty of a copyright violation.

6. RESTRICTIONS

You may not publish, display, disclose, rent, lease, modify, loan, or create derivative works based on the Software or any part thereof. You may not reverse engineer, decompile, translate, adapt, or disassemble the Software, nor shall you attempt to create the source code from the object code for the Software. You may not transmit the Software over any network or between any devices, although you may use the Software to make such transmissions of other materials. You may transfer the Software to other computers you own as long as you only use it on one computer at a time.

7. CONFIDENTIALITY

You acknowledge that the Software contains proprietary trade secrets of PrestoSoft LLC and you hereby agree to maintain the confidentiality of the Software using at least as great a degree of care as you use to maintain the confidentiality of your own most confidential information. You agree to reasonably communicate the terms and conditions of this Software License Agreement to those persons employed by you who come into contact with the Software, and to use reasonable best efforts to ensure their compliance with such terms and conditions, including, without limitation, not knowingly permitting such persons to use any portion of the Software for the purpose of deriving the source code of the Software or defeating the Key.

8. DISCLAIMER OF WARRANTY

THIS SOFTWARE AND MANUAL ARE PROVIDED "AS IS" AND WITHOUT WARRANTIES AS TO PERFORMANCE OF MERCHANTABILITY OR ANY OTHER WARRANTIES WHETHER EXPRESSED OR IMPLIED. BECAUSE OF THE VARIOUS HARDWARE AND SOFTWARE ENVIRONMENTS INTO WHICH THIS PROGRAM MAY BE PUT, NO WARRANTY OF FITNESS FOR A PARTICULAR PURPOSE IS OFFERED. GOOD DATA PROCESSING PROCEDURE DICTATES THAT ANY PROGRAM BE THOROUGHLY TESTED WITH NON-CRITICAL DATA BEFORE RELYING ON IT. THE USER MUST ASSUME THE ENTIRE RISK OF USING THE PROGRAM.

9. LIMITATION OF LIABILITY

IN NO EVENT WILL PRESTOSOFT BE LIABLE TO YOU OR ANY THIRD PARTY FOR ANY INCIDENTAL OR CONSEQUENTIAL DAMAGES (INCLUDING, WITHOUT LIMITATION, INDIRECT, SPECIAL, PUNITIVE, OR EXEMPLARY DAMAGES FOR LOSS OF BUSINESS, LOSS OF PROFITS, BUSINESS INTERRUPTION, OR LOSS OF BUSINESS INFORMATION) ARISING OUT OF THE USE OF OR INABILITY TO USE THE SOFTWARE, OR FOR ANY CLAIM BY ANY OTHER PARTY, EVEN IF PRESTOSOFT HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. PRESTOSOFT'S AGGREGATE LIABILITY WITH RESPECT TO ITS OBLIGATIONS UNDER THIS AGREEMENT OR OTHERWISE WITH RESPECT TO THE SOFTWARE AND DOCUMENTATION OR OTHERWISE SHALL NOT EXCEED THE AMOUNT OF THE LICENSE FEE PAID BY YOU FOR THE SOFTWARE AND DOCUMENTATION. BECAUSE SOME STATES/COUNTRIES DO NOT ALLOW THE EXCLUSION OR LIMITATION OF LIABILITY FOR CONSEQUENTIAL OR INCIDENTAL DAMAGES, THE ABOVE LIMITATION MAY NOT APPLY TO YOU.

10. EXPORT RESTRICTIONS

THIS LICENSE AGREEMENT IS EXPRESSLY MADE SUBJECT TO ANY LAWS, REGULATIONS, ORDERS, OR OTHER RESTRICTIONS ON THE EXPORT FROM THE UNITED STATES OF AMERICA OF THE SOFTWARE OR INFORMATION ABOUT SUCH SOFTWARE WHICH MAY BE IMPOSED FROM TIME TO TIME BY THE GOVERNMENT OF THE UNITED STATES OF AMERICA. YOU SHALL NOT EXPORT THE SOFTWARE, DOCUMENTATION, OR INFORMATION ABOUT THE SOFTWARE AND DOCUMENTATION WITHOUT CONSENT OF PRESTOSOFT AND COMPLIANCE WITH SUCH LAWS, REGULATIONS, ORDERS, OR OTHER RESTRICTIONS.

11. NEW VERSIONS OF THE SOFTWARE

PrestoSoft LLC, in its sole discretion, reserves the right to add additional features or functions, or to provide programming fixes, updates and upgrades, to the Software. You acknowledge and agree that PrestoSoft LLC has no obligation to make available to you any subsequent versions of the Software. You also agree that you may have to enter into a renewed version of this Agreement, in the event you want to download, install or use a new version of the Software. Furthermore, you acknowledge and agree that PrestoSoft LLC, in its sole discretion, may modify or discontinue or suspend your ability to use any version of the Software, and/or disable any PrestoSoft LLC Software you may already have accessed or installed without any notice to you, for the repair, improvement, and/or upgrade of the underlying technology or for any other justifiable reason, including but not limited to, circumstances where you, at PrestoSoft LLC’s discretion, are in breach of this Agreement, creating problems, possible legal liabilities, or engaging in fraudulent, immoral or illegal activities, or for other similar reasons. PrestoSoft LLC will not accept any liability in relation to the direct or indirect damages caused by (1) the release and/or the absence of release of new versions of the Software and (2) by the suspension or termination of the license or this Agreement by PrestoSoft LLC and/or by you.

12. HIGH-RISK ACTIVITIES

THIS SOFTWARE IS NOT FAULT TOLERANT AND IS NOT DESIGNED, MANUFACTURED, OR INTENDED FOR USE OR RESALE AS ONLINE CONTROL EQUIPMENT IN HAZARDOUS ENVIRONMENTS REQUIRING FAIL-SAFE PERFORMANCE, SUCH AS IN THE OPERATION OF NUCLEAR FACILITIES, AIRCRAFT NAVIGATION OR COMMUNICATION SYSTEMS, AIR TRAFFIC CONTROL, DIRECT LIFE SUPPORT MACHINES, OR WEAPONS SYSTEMS, IN WHICH THE FAILURE OF THIS SOFTWARE COULD LEAD DIRECTLY TO DEATH, PERSONAL INJURY, OR SEVERE PHYSICAL OR ENVIRONMENTAL DAMAGE.

13. GOVERNING LAW

This License Agreement shall be construed, interpreted and governed by the laws of the United States of America without regard to conflicts of law provisions thereof. The exclusive forum for any disputes arising out of or relating to this License Agreement shall be an appropriate court sitting in California, the United States of America.

14. TERMINATION

This License Agreement is effective until it is terminated. You may terminate this License Agreement at any time by destroying or returning to PrestoSoft LLC all copies of the Software and Documentation in your possession or under your control. PrestoSoft LLC may terminate this License Agreement for any reason, including, but not limited to, if PrestoSoft LLC finds that you have violated any of the terms of this License Agreement. Upon notification of termination, you agree to destroy or return to PrestoSoft LLC all copies of the Software and Documentation and to certify in writing that all known copies, including backup copies, have been destroyed. All provisions relating to confidentiality, proprietary rights, and non-disclosure shall survive the termination of this Software License Agreement.

15. ENTIRE AGREEMENT

This is the entire agreement between you and PrestoSoft LLC. It supersedes any prior agreement or understanding, whether written or oral, relating to the subject matter of this license.


Bug Reports And Feature Requests

Before submitting a bug report or a feature request, please consult the ExamDiff Pro FAQ and the PrestoSoft Forums.

If your question is not answered, submit bug reports, new feature requests, and comments using this form.

You can also vote for an existing suggestion or propose a new one here.

You can also submit bug reports and suggestions to PrestoSoft by mail, to:

P.O. Box 3611
Thousand Oaks, CA 91359


How to Order ExamDiff Pro

This program is not free, but is copyrighted software that is provided to allow you to evaluate it before paying. If you make use of this software for any purpose other than evaluation or evaluates it for a longer period than 30 days, then you must purchase the software.

In order to purchase the software you need to send your name (or any name you would like to register the software to) and payment (see options below). When payment is received, you will be e-mailed (if e-mail address is included) or mailed a password necessary to register the software. After getting an e-mail message with your password, follow the registration instructions, which will result in the creation of a password file in the same directory where ExamDiff.exe is located. When run, ExamDiff Pro will use the file to validate your registration. Please do not remove your password file from the ExamDiff Pro directory.

Upgrades are free for 12 months since the purchase of ExamDiff Pro. After 12 months pass, you may (1) use the latest of your free upgrades forever, or (2) renew your license for the next 12 months at the current license renewal rate (see ExamDiff Pro Pricing for current upgrade prices). To order an upgrade, please e-mail PrestoSoft LLC with your current registration name and number of licenses you own (you can find this information in the About Box). In return you will be e-mailed instructions on how to purchase an upgrade. If you purchased ExamDiff Pro more than once, and you wish to upgrade all of your separate licenses in one consolidated upgrade, please e-mail all of your registration names along with number of licenses for each registration.

There are several ways to purchase ExamDiff Pro:

  1. By credit card:
    Visit http://www.prestosoft.com/edp_purchase.asp for different ways of ordering ExamDiff Pro via credit card.

  2. By purchase order:
    PrestoSoft LLC does not process POs directly. Visit http://www.prestosoft.com/edp_po.asp for the ways of ordering ExamDiff Pro via POs.

  3. By check, money order, or cash (US dollars only):
    • Print and fill the order form
    • Send the filled order form along with a check, money order, or cash payable to PrestoSoft LLC, to
      P.O. Box 3611
      Thousand Oaks, CA 91359

  4. By wire transfer:
    • Please e-mail PrestoSoft LLC to find out bank information necessary to complete wire transfer
    • Transfer funds
    • Print and fill the order form
    • E-mail the filled order form to PrestoSoft LLC or send it to
      P.O. Box 3611
      Thousand Oaks, CA 91359
    • Note: For security reasons, we only accept wire transfers for orders of 50 or more licenses.

To check on the status of your order, please contact PrestoSoft LLC directly.

The credit card orders are handled by third party registration services. They notify PrestoSoft LLC, and within one business day of your order PrestoSoft LLC will send your password directly to you.


ExamDiff Pro Pricing

The latest pricing information for ExamDiff Pro can always be found at http://www.prestosoft.com/edp_pricing.asp.

The password(s) will be sent by e-mail. If you prefer postal mail, please add $5.00.


ExamDiff Pro Order Form

Name: | __________________________________________________
Registration name: | __________________________________________________
Number of licenses: | __________________________________________________
Company: | __________________________________________________
Street Number: | __________________________________________________
City, State, Zip (postal code): | __________________________________________________
Country: | __________________________________________________
E-mail: | __________________________________________________
Comments: | __________________________________________________
 | __________________________________________________
 | __________________________________________________
 | __________________________________________________
 | __________________________________________________


Credits

ExamDiff Pro uses the following third party libraries. We thank their authors for making them available.

  • Boost Regular Expression Library (Regex++)
    Copyright (c) 1998-2004
    Dr John Maddock
    http://www.boost.org

  • Crystal Edit Library
    by Andrei Stcherbatchenko, with changes by Ferdinand Prantl

  • HexView Library
    Copyright (C) J Brown 2001
    http://freespace.virgin.net/james.brown7/hexedit.html

  • Inno Setup
    Copyright (C) 1997-2007 Jordan Russell
    http://www.jrsoftware.org


ExamDiff Pro Help Contents

Getting Started

Features
Getting started
Menus and toolbars
Status bars
Diff bars
Context menus
Sessions
File editing and merging
Manual synchronization
Plug-ins
Drag and drop
Unicode support
Options
Command line options

Commands

Files/Directories menu
Edit menu
View menu
Navigation menu
Search menu
Help menu

Information

End-user license agreement
Bug reports and feature requests
Ordering information
ExamDiff Pro pricing
ExamDiff Pro Order Form
Credits


Plug-in Details

Plug-in Details dialog

Dialog Box Options

Name
The name of the plug-in.

Extensions
Extension(s) which you want to be pre-processed by an application, listed below, before comparison. Do not use dots; separate multiple extensions by commas. If ‘*’ extension is used, all files will be pre-processed by the application.

If <inline> is set in this field or if no extension is set, the plug-in is for inline use only. If <default-remote-file> or <default-remote-directory> is set in this field, the plug-in will be used by ExamDiff Pro for remote file or directory comparison, respectively, and will be automatically used when a file or directory is in the form of a URL (such as ftp://ftp.server.com/test.txt). There can only be one remote file and only one remote directory plug-in, and an error message will be given if you try to set more than one of either.

Application
An executable or a batch file that takes at least one parameter (input file name).

Arguments
Need to include at least one parameter ($INPUTFILEPATH or $INPUTFILEDIR$INPUTFILENAME$INPUTFILEEXT); if no output file name ($OUTPUTFILEPATH) is used, standard output is assumed. For older, DOS-based programs, you may need to use $INPUTFILENAME_SHORT or $INPUTFILEPATH_SHORT, which provide short (8.3) path and file name respectively.

Here's the full list of built-in arguments:

$INPUTFILEPATH | Full path of the input file
$INPUTFILEDIR | Input file directory
$INPUTFILENAME | Input file name (without directory and extension)
$INPUTFILEEXT | Input file extension
$OUTPUTFILE | Full path of the output file
$INPUTFILEPATH_SHORT | Short path of the input file
$INPUTFILENAME_SHORT | Input file's short name
$OPPOSITEFILEPATH | Full path of the opposite file
$TABSIZE | Tab size

Use exit code
Use this option in order to let ExamDiff Pro generate an error message if the application did not exit with a success exit code (see below).

Success exit code
Success exit code of the application (usually 0).


Include/Exclude Filters

Filters Options dialog

Dialog Box Options

  • Include Filters
    The list of Include Name Filters in the current filter set.

  • Exclude Filters
    The list of Exclude Name Filters in the current filter set.

  • Toolbars

    • Add new filter
      Adds a new filter below the currently selected filter.

    • Edit filter
      Renames the currently selected filter.

    • Delete filter
      Deletes the currently selected filter.

    • Move filter up
      Swaps the positions of the currently selected filter and the filter above it.

    • Move filter down
      Swaps the positions of the currently selected filter and the filter below it.

    Swapping the position of filters may be useful because ExamDiff Pro executes filters in order, one at a time. Placing the broadest filters first may speed up execution, although the difference in performance is usually negligible.

  • Filter Details

    • Type
      Select File name to match only the name of files/directories or File path to match both the name and the directory path. Selecting File path is equivalent to prefixing the filter with ':'.

    • Enable
      Check the box to enable the filter or uncheck it to disable it. Unchecking the box is equivalent to prefixing the filter with '|'.


Regular Expressions

Regular Expressions are a concise and flexible notation for finding and replacing patterns of text. Regular expression support in ExamDiff Pro is based on the Boost Regular Expression Library. ExamDiff Pro uses Perl regular expression syntax.

The table below shows the Regular Expressions that can be inserted into the Find or Replace boxes, used to ignore lines or line parts in Compare Options, or used to define comments in Document Types Options.

For more information and tutorials on regular expressions visit Regular-Expressions.info.

Expression | Syntax | Description
Literals |  | All characters are literals except: ".", "|", "*", "?", "+", "(", ")", "{", "}", "[", "]", "^", "$" and "\". These characters are literals when preceded by a "\".
Any Character | . | Matches any one character.
Zero or More | * | Matches zero or more occurrences of the preceding expression. For example, "ba*" will match all of "b", "ba", "baaa" etc.
One or More | + | Matches at least one occurrence of the preceding expression. For example, "ba+" will match "ba" or "baaaa" for example but not "b".
Zero or One | ? | Matches zero or one occurrence of the preceding expression. For example, "ba?" will match "b" or "ba".
Number of Repeats | {} | Used to specify the minimum and maximum number of repeats. For example, "a{2}" is the letter "a" repeated exactly twice, "a{2,4}" represents the letter "a" repeated between 2 and 4 times, and "a{2,}" represents the letter "a" repeated at least twice with no upper limit.
Grouping | () | Groups a sub expression. For example the expression "(ab)*" would match all of the string "ababab".
Or | | | Matches the expression before or after the |. Mostly used within a group. For example, "(sponge)|(mud) bath" matches "sponge bath" and "mud bath."
Set of Characters | [] | Matches any one of the characters within the []. To specify a range of characters, list the starting and ending character separated by a dash (-), as in [a-z]. For example, "[abc]" will match either of "a", "b", or "c".
Character Not in Set | [^] | Matches any character not in the set of characters following the ^. For example, "[^abc] will match any character other than "a", "b", or "c".
Character Classes |  | Character classes are denoted using the syntax "[:classname:]" within a set declaration, for example "[[:space:]]" is the set of all whitespace characters. The available character classes are:
 | [:alnum:] | Any alpha-numeric character.
 | [:alpha:] | Any alphabetical character a-z and A-Z. Other characters may also be included depending upon the locale.
 | [:blank:] | Any blank character, either a space or a tab.
 | [:cntrl:] | Any control character.
 | [:digit:] or \d | Any digit 0-9.
 | [:graph:] | Any graphical character (a printable character other than a space).
 | [:lower:] or \l | Any lower case character a-z. Other characters may also be included depending upon the locale. Note that this character class has to be used in conjunction with "Match case" option.
 | [:print:] | Any printable character.
 | [:punct:] | Any punctuation character.
 | [:space:] or \s | Any whitespace character.
 | [:upper:] or \u | Any upper case character A-Z. Other characters may also be included depending upon the locale. Note that this character class has to be used in conjunction with "Match case" option.
 | [:xdigit:] | Any hexadecimal digit character, 0-9, a-f and A-F.
 | [:word:] or \w | Any word character - all alphanumeric characters plus the underscore.
 | [:unicode:] | Any character whose code is greater than 255, this applies to the wide character traits classes only.
Character by Octal Code | \0#### | Escape character followed by the digit "0" followed by the octal character code. For example "\023" represents the character whose octal code is 23. Where ambiguity could occur use parentheses to break the expression up: "\0103" represents the character whose code is 103, "(\010)3 represents the character 10 followed by "3". Use with "Match case" option.
Character by Hexadecimal Code | \x#### | \x followed by a string of hexadecimal digits, optionally enclosed inside {}, for example \xf0 or \x{aff}. Use with "Match case" option.
Beginning of Line | ^ | Starts the match at the beginning of a line (significant only at the start of an expression).
End of Line | $ | Anchors the match to the end of a line (significant only at the end of an expression).


Save Session

If the current session is a session from file, this command saves all changes to the current session.

If no session file has been loaded, this command behaves identically to the Save As ... command, that is, it saves the current session to a user-specified session file.